//删除了Jpush相关的插件
!function(){
  'use strict';
  //可加载模块列表
  var lazyModules = ['portal','taskarrangement','personManage','middleware','projectList','qLists','projectDynamics','todaytask', 'performTask','riskWarning','safetyCheckRecord','workloadReporting','attendanceRecord','costManagement','communication'];

  var lazyConfig = {
    modules: ['ionic', 'ngCordova', 'angular-echarts', 'angular-md5', 'base64', 'ionic.rating', 'ion-datetime-picker', 'ionic-modal-select', 'ngStomp', 'app.config', 'app.messages', 'app.directives', 'app.filters', 'app.interceptors', 'app.services'],
    required: [],
    resources: {}
  };

  var APPUtil = {
    getFileData: function (url, callback) {
      var request = new XMLHttpRequest();
      request.open("GET", url, false);
      request.onreadystatechange = function () {
        if (request.readyState !== 4) return;
        if (request.status === 200 || request.status === 0) {
          callback(request.responseText);
        }
      };
      request.send(null);
    }
  };

  //解析模块
  var resolveModules = function (modules) {
    modules.forEach(function (module) {
      var modulePrefix = "modules/" + module;
      APPUtil.getFileData(modulePrefix + "/config.json", function (config) {
        config = JSON.parse(config);
        var exports = config.exports;

        for (var i in config.modules) {
          lazyConfig.modules.push(config.modules[i]);
        }

        for (var name in exports) {
          var requiredName = module + '.' + name;
          lazyConfig.required.push(requiredName);
          lazyConfig.resources[requiredName] = modulePrefix + '/' + exports[name];
        }
      });
    });
  };

  resolveModules(lazyModules);

  require.config({
    paths: lazyConfig.resources
  });

  require.onError = function (err) {
      console.error(err);
  };

  define(lazyConfig.required, function (app) {
    'use strict';
    var main = angular.module('app', lazyConfig.modules);
    main.config(function ($ionicConfigProvider, $httpProvider, ENV) {
      $httpProvider.interceptors.push('RequestTokenInterceptor');
      $httpProvider.interceptors.push('RequestErrorInterceptor');
      //$ionicConfigProvider.views.maxCache(0);
      $ionicConfigProvider.platform.ios.backButton.text('返回');
      $ionicConfigProvider.tabs.position('bottom');
      $ionicConfigProvider.tabs.style('striped');
      $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
      $ionicConfigProvider.platform.android.navBar.alignTitle('left');
      $ionicConfigProvider.platform.ios.views.transition('ios');
      $ionicConfigProvider.platform.android.views.transition('android');
      $ionicConfigProvider.platform.ios.views.swipeBackEnabled(false);
      $ionicConfigProvider.views.transition('none');
    });

    // 日期控件国际化
    main.run(function ($ionicPickerI18n) {
      $ionicPickerI18n.title = "日期选择";
      $ionicPickerI18n.weekdays = ["日", "一", "二", "三", "四", "五", "六"];
      $ionicPickerI18n.months = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
      $ionicPickerI18n.ok = "确定";
      $ionicPickerI18n.cancel = "取消";
    });

    //view全局变量
    main.run(function($rootScope, ENV){
      $rootScope.ENV = ENV;
      $rootScope.rootZJdata = [];// 定义通讯录全局变量
    });

    main.run(function ($q, $http, $base64, Storage, $ionicHistory, $location, $ionicPlatform, $rootScope, $state, $log, $cordovaToast, $cordovaDevice, $ionicPopup, $ionicLoading, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, ENV, System, AuthService, $timeout) {
      $ionicPlatform.ready(function () {
        //消息提示弹框
        function showAlert(message, title) {
          var alertPopup = $ionicPopup.alert({
            title: title || '提示信息',
            template: message,
            okText: '确定',
            okType: 'bar-iccs light font-yahei'
          });
        };

        //确认对话框
        function skypeConfirmAlert(title, message, params) {
         var confirmPopup = $ionicPopup.confirm({
           title: title || '提示信息',
           template: message,
           cancelText: '取消',
           cancelType: 'button-assertive',
           okText: '确定',
           okType: 'bar-iccs light font-yahei'
         });
         confirmPopup.then(function(res) {
           if(res) {

           }
         });
       };

        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          cordova.plugins.Keyboard.disableScroll(true);
        }



        if(window.device) {
          var platformBadge = $cordovaDevice.getPlatform();
          if (platformBadge != 'iOS') {
            if (window.StatusBar) {
              StatusBar.styleLightContent();
            }
          }
        }

        if (window.cordova && window.cordova.InAppBrowser) {
          window.open = window.cordova.InAppBrowser.open;
        }

        //$rootScope.canOA = Storage.get('canOA');
        //刷新Token
        var refreshToken = function(){
            //获取上次获取token的时间
            var date1 = Storage.get('getTokenTime');
            var needRE = false;
            if(date1){
              var date2=new Date();
              var date1 = new Date(date1.replace(/-/g, '/'));
              var date3=date2.getTime()-date1.getTime();
              var leave1=date3%(24*3600*1000);
              var hours=Math.floor(leave1/(3600*1000));
              //超过2天需要刷新
              if(hours>=48){
                needRE = true;
              }
            }else{
              needRE = true;
            }

            //刷新token
            if(needRE){
              Date.prototype.pattern=function(fmt) {
                  var o = {
                  "M+" : this.getMonth()+1, //月份
                  "d+" : this.getDate(), //日
                  "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时
                  "H+" : this.getHours(), //小时
                  "m+" : this.getMinutes(), //分
                  "s+" : this.getSeconds(), //秒
                  "q+" : Math.floor((this.getMonth()+3)/3), //季度
                  "S" : this.getMilliseconds() //毫秒
                  };
                  var week = {
                  "0" : "/u65e5",
                  "1" : "/u4e00",
                  "2" : "/u4e8c",
                  "3" : "/u4e09",
                  "4" : "/u56db",
                  "5" : "/u4e94",
                  "6" : "/u516d"
                  };
                  if(/(y+)/.test(fmt)){
                      fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
                  }
                  if(/(E+)/.test(fmt)){
                      fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);
                  }
                  for(var k in o){
                      if(new RegExp("("+ k +")").test(fmt)){
                          fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
                      }
                  }
                  return fmt;
              }
              if(!Storage.get('isLogged')){
                return;
              }
              $ionicLoading.show({
                template: '<ion-spinner icon="android" class="spinner-assertive"></ion-spinner>',
                noBackdrop: true
              });
              var currentUser = Storage.get('currentUser');
              var refreshToken = Storage.get('refreshToken');
              AuthService.getAccessTokenByRefreshToken(refreshToken).success(function(data){
                $log.log('刷新页面refreshToken...', data);
                Storage.set('accessToken', data.access_token);
                Storage.set('currentUser', angular.extend({}, currentUser, data.userInfo));
                Storage.set('isLogged', true);
                //设置本次获取token的时间
                Storage.set('getTokenTime',new Date().pattern("yyyy-MM-dd HH:mm:ss"));
              }).error(function(data) {
                $log.error('refreshToken失败.', data);
                $ionicLoading.hide();
                Storage.set('isLogged', false);
                $cordovaToast.showShortBottom('对不起，网络异常，请稍后再试！');
              });
            }
        };
                           if(window.device){
                           var platformBadge = $cordovaDevice.getPlatform();
                           if (platformBadge === 'iOS') {
                           window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
                           window.plugins.jPushPlugin.resetBadge();
                           }
                           }
        //app重新打开
        $ionicPlatform.on("resume", function(){
                          if(window.device){
                          var platformBadge = $cordovaDevice.getPlatform();
                          if (platformBadge === 'iOS') {
                          window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
                          window.plugins.jPushPlugin.resetBadge();
                          }
                          }
          //检查更新
          if(window.device){
            System.checkUpdate().success(function(data){
              if(!data) return;
              var versionCode = data.versionCode;
              if(parseInt(versionCode) > ENV.versionCode){
                checkUpdate(data);
              }
              //checkUpdate(data);
            }).error(function(e){
              //$cordovaToast.showShortBottom(e);
            });
          }

          //app刷新系统token
          //refreshToken();
        });

        // $ionicPlatform.on("jpush.receiveMessage", function (data) {
        //   //如果收到视频会议邀请跳转到加入会议页面
        //   /*var params  = JSON.parse(data.extras.extras);
        //   if(data.extras.itemType == 'videocall'){
        //     $state.go('fuhui.waiting',{name:params.userName,address:params.address,dept:params.dept,initorId:params.userId,meetingId:params.videoId,mobilePhone:params.mobilephone,initorDept:params.initorDept,initorName:params.initorName,initorPhotoUrl:params.initorPhotoUrl});
        //   }*/
        //   var itemType = data.extras.itemType,
        //       extras = data.extras.extras,
        //       pushEnv = data.extras.env;
        //   if(!itemType || itemType.length == 0){
        //     return;
        //   }
        //
        //   switch (itemType) {
        //     case 'videocall':
        //       //如果收到视频会议邀请跳转到加入会议页面
        //       var params = JSON.parse(extras);
        //       $state.go('fuhui.waiting', {
        //         name: params.userName,
        //         address: params.address,
        //         dept: params.dept,
        //         initorId: params.userId,
        //         meetingId: params.videoId,
        //         mobilePhone: params.mobilephone,
        //         initorDept: params.initorDept,
        //         initorName: params.initorName,
        //         initorPhotoUrl: params.initorPhotoUrl
        //       });
        //       break;
        //     default:
        //       $log.log('ReceivedNewMessage:', itemType, extras);
        //       return;
        //   }
        //   $rootScope.$broadcast('$ReceivedNewMessage', itemType, extras);
        // });

        // $ionicPlatform.on("jpush.openNotification", function (data) {
        //   $log.log('jpush.openNotification', data);
        // });

        $ionicPlatform.on("jpush.openNotification", function (data) {
          $timeout(function() {

            var params;
            var url;
            var platformBadge = $cordovaDevice.getPlatform();
            if (platformBadge === 'iOS') {

              params = JSON.parse(data.extras);
              url = params.appUrl;
            } else {
              params = JSON.parse(data.extras.extras);
              url = params.appUrl;
            }

            $location.path(url);
            $rootScope.$apply();
          }, 3000);
        });

        //设备初始化完毕事件
        $ionicPlatform.on("deviceready", function () {
          // SkypePlugin.init();
          // $log.log('SkypePlugin init on deviceready...');
          // $log.log('deviceready ...')
          navigator.splashscreen.hide();
          plugins.jPushPlugin.init();

          //启动极光推送服务
          // Jpush.init(function (data){
          //     $log.log('Open Notification...', data);
          //     //如果不是skpe视频会议消息在通知栏发送消息
          //     if(data.alert != '视频通话邀请'){
          //       var alertMsg = JSON.stringify(data.alert);
          //       alertMsg = alertMsg.replace("\"","").replace("\"","");
          //       showAlert(alertMsg);
          //     }
          // });

          //$cordovaToast.showShortBottom("当前网络：" + navigator.connection.type);
          //检查是否修改过密码
          // if(Storage.get('isLogged')){
          //     checkUpdatePassword();
          // }

          //测试
          //skypeConfirmAlert('李翔邀请你视频会议','李翔邀请你视频会议','111');

          if (window.screen) {
            //window.screen.lockOrientation('portrait');
          }
        }, false);

        //检查更新
        if(window.device){
          System.checkUpdate().success(function(data){
            if(!data) return;
            var versionCode = data.versionCode;
            if(parseInt(versionCode) > ENV.versionCode){
              checkUpdate(data);
            }
            //checkUpdate(data);
          }).error(function(e){
            //$cordovaToast.showShortBottom(e);
          });
        }

        //检查更新
        // if(window.device){
        //   var deviceType = 1,
        //       platformType = 1,
        //       platform = $cordovaDevice.getPlatform();
        //   $rootScope.isIosWeb = ionic.Platform.isIOS();//用于修复 复制粘贴bug
        //   if(platform === 'iOS'){
        //     deviceType = 2;
        //   }
        //   if(ENV.name === 'production'){
        //     platformType = 2;
        //   }
        //   System.checkUpdate(deviceType, platformType).success(function(data){
        //     if(!data) return;
        //     var versionCode = data.version_code;
        //     if(parseInt(versionCode) > ENV.versionCode){
        //       checkUpdate({
        //         info: data.info,
        //         url: data.url
        //       });
        //     }
        //     //checkUpdate(data);
        //   }).error(function(e){
        //     //$cordovaToast.showShortBottom(e);
        //   });
        // }
      });

      //主页面显示退出提示框
      $ionicPlatform.registerBackButtonAction(function (e) {
        e.preventDefault();
        function showConfirm() {
            var confirmPopup = $ionicPopup.confirm({
                title: '<strong>退出应用</strong>',
                template: '您确定要退出应用吗?',
                okText: '退出',
                okType: 'bar-iccs light font-yahei',
                cancelText: '取消'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    // 断开自己所有相关的视频通话
                    var currentUser = Storage.get('currentUser');
                    if (currentUser && currentUser.telephone) {
                      var userId = currentUser.id;
                      VideoService.updateVideoUserStatusToLeaved(userId).success(function (data) {
                        console.log("视频通话已断开");
                      });
                    }
                    ionic.Platform.exitApp();
                } else {

                }
            });
        }

        if ($location.path() == '/tabs/home/message' || $location.path() == '/login'){
            showConfirm();
        } else if($location.path() == '/uie/bulletin/read/0' || $location.path() == '/uie/bulletin/readed/1'){
            $state.go('tabs.office');
        } else if ($ionicHistory.backView()) {
            $ionicHistory.goBack();
        } else {
            showConfirm();
        }
        return false;
      }, 101);

      //检查更新
      function checkUpdate(data){
        if(!window.cordova){
          return;
        }
        $cordovaAppVersion.getVersionNumber().then(function (version) {
          var confirmPopup = $ionicPopup.confirm({
              title: '版本更新',
              template: '发现新版本，需要升级！',
              buttons: [
                 {
                   text: '<b>升级</b>',
                   type: 'button-positive',
                   onTap: function(e) {
                       var fileName = new Date().getTime() + '.apk',
                           platform = $cordovaDevice.getPlatform();
                       if(platform === 'iOS'){
                         window.open(data.iosAddress, '_blank', 'location=no,toolbarposition=top,closebuttoncaption=返回');
                         return;
                       }
                       $ionicLoading.show({
                         template: "正在更新，请稍候..."
                       });

                       var targetDir = cordova.file.externalDataDirectory || cordova.file.dataDirectory,
                           targetPath = targetDir + fileName,
                           trustHosts = true,
                           options = {};

                       $cordovaFileTransfer.download(data.androidAddress, targetPath, options, trustHosts).then(function (result) {
                         $ionicLoading.hide();
                         $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function () {
                           // 成功
                         }, function (err) {
                           // 错误
                         });
                       }, function (err) {
                         $log.error('文件下载失败', err);
                         $ionicLoading.hide();
                         $cordovaToast.showShortBottom('更新失败，请稍候再试...');
                       }, function (progress) {
                         /*$timeout(function () {
                             var total = progress.loaded/1024;
                             $ionicLoading.show({
                                 template: "已经下载：" + total + "KB"
                             });
                         });*/
                       });
                   }
                 },
               ]
          });

          confirmPopup.then(function (res) {
            if(res){
            }
          });
        });
      }

      //检查更新
      // function checkUpdate(data){
      //   if(!window.cordova){
      //     return;
      //   }
      //   $cordovaAppVersion.getVersionNumber().then(function (version) {
      //     var confirmPopup = $ionicPopup.confirm({
      //         title: '版本更新',
      //         template: data.info,
      //         cancelText: '取消',
      //         okText: '升级'
      //     });
      //
      //     confirmPopup.then(function (res) {
      //       if(res){
      //         var url = data.url,
      //             fileName = new Date().getTime() + '.apk',
      //             platform = $cordovaDevice.getPlatform();
      //         if(platform === 'iOS'){
      //           window.open(url, '_blank', 'location=no,toolbarposition=top,closebuttoncaption=返回');
      //           return;
      //         }
      //         $ionicLoading.show({
      //           template: "正在更新，请稍候..."
      //         });
      //
      //         var targetDir = cordova.file.externalDataDirectory || cordova.file.dataDirectory,
      //             targetPath = targetDir + fileName,
      //             trustHosts = true,
      //             options = {};
      //
      //         $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
      //           $ionicLoading.hide();
      //           $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function () {
      //             // 成功
      //           }, function (err) {
      //             // 错误
      //           });
      //         }, function (err) {
      //           $log.error('文件下载失败', err);
      //           $ionicLoading.hide();
      //           $cordovaToast.showShortBottom('更新失败，请稍候再试...');
      //         }, function (progress) {
      //           /*$timeout(function () {
      //               var total = progress.loaded/1024;
      //               $ionicLoading.show({
      //                   template: "已经下载：" + total + "KB"
      //               });
      //           });*/
      //         });
      //       }
      //     });
      //   });
      // }

      //检查是否修改过密码,
      //根据changePasswordCount是否为0判断修改密码.
      function checkUpdatePassword(){
        var currentUser = Storage.get('currentUser');
        //检查是否修改过密码
        // if(currentUser.changePasswordCount == 0){
        //   $state.go('mandatory_checkSetPassword');
        //   $cordovaToast.showShortBottom('为了您的账号安全，请及时修改默认密码.');
        // } else {
        //   $state.go('tokenLoading');
        // }
      }

      // function checkUpdatePassword(){
      //   $http({
      //     method: 'POST',
      //     url: ENV.api + '/login/checkUpdatePassword',
      //     dataType: "json",
      //     params: {
      //       telephone: $base64.encode(Storage.get('currentUser').telephone)
      //     }
      //   }).success(function(res){
      //     if(!res || !res.record){
      //       return;
      //     }
      //     if(res.record.updateFlag == 0){
      //       $state.go('mandatory_checkSetPassword');
      //       $cordovaToast.showShortBottom('为了您的账号安全，请及时修改默认密码.');
      //     }else{
      //       $state.go('tabs.home.message');
      //     }
      //   });
      // };

    });

    main.run(function($rootScope, $state,$ionicLoading, $log, ENV, Storage,$timeout,$cordovaDevice){
      $rootScope.$on("$stateChangeStart", function (event, toState, toParams, fromState, fromParams) {
        $ionicLoading.hide();
        if(typeof($rootScope.isAccess) != 'undefined' && !$rootScope.isAccess){
          Storage.set('isLogged', false);
          $rootScope.isAccess = true;
        }

        if(window.device){
          var platformBadge = $cordovaDevice.getPlatform();
          if (platformBadge === 'iOS') {
            if (window.StatusBar) {

              $timeout(function() {

                StatusBar.overlaysWebView(false);
                StatusBar.backgroundColorByHexString('#e1272a');
              }, 2800);

            }
          }
        }



        //$log.log(toState);
        $rootScope.hideTabs = true;//fix tabs hide bug if state change(解决点击首件各个模块时，下面会出现nav闪现)
        if (toState.name == 'login') return;
        var loginRequried = (toState.loginRequried == undefined ? true : toState.loginRequried),
          isLogged = Storage.get('isLogged') || false;
        //$log.log(toState.url, toState.loginRequried, loginRequried, isLogged);
        $rootScope.loginRequried = loginRequried;
        if (loginRequried && !isLogged) {
          //$log.log('===');
          event.preventDefault();
          $state.go('login');
          return false;
        }
      });
      $rootScope.$on("$authSuccess", function(){
        $log.log('auth success...');
        var alias = Storage.get('useridNumStr');

        //        if(ENV.name === 'development'){
        //            alias = "test_" + alias;
        //            $log.log("ENV[development] alias....", alias);
        //        }
        // Jpush.setAlias(alias);
        try{

          window.JPush.setAlias({ sequence: 1, alias: alias },function (success) {

            console.log(success);

          },function (error) {
            console.log(error);
          });
        }catch(e){

        }

      });
    });

    angular.bootstrap(document, ['app']);
  });
}();
