!function(){
  'use strict';
  var interceptors = angular.module('app.interceptors', []);
  interceptors.factory('RequestTokenInterceptor', function($log, Storage, ENV, $injector){
    var TokenInjector = {
      request: function(config){
        var currentRequestUrl = config.url;
        if(currentRequestUrl.indexOf(ENV.api) > -1){
          //TODO 爱通服请求
          //$log.log('Current Request Api is 爱通服');
        } else if(currentRequestUrl.indexOf(ENV.uieApi) > -1){
          config.params.token = Storage.get('uieToken');
        } else if(currentRequestUrl.indexOf(ENV.reportApi) > -1){
          if(!config.params){
            config.params = {};
          }
          config.params.userName = Storage.get('currentUser').telephone;
        }
        //所有请求添加access_token
        if(currentRequestUrl.indexOf(ENV.apiGateway) == -1 && currentRequestUrl.indexOf('.html') == -1){
          if(!config.params){
            config.params = {};
          }
          config.params.access_token = Storage.get('accessToken');
        }
        return config;
      },
      response: function(response){
        if(response.config.url.indexOf(ENV.uieApi) > -1&&response.data&&response.data.msg&&response.data.msg.lastIndexOf('请重新登录')>-1){//token过期了
          return $injector.get("UieLoginService").loginAndRetry(Storage.get('currentUser').telephone,response);
        }
        //$log.log('response', response);
        return response;
      }
    };
    return TokenInjector;
  });

  interceptors.factory('RequestErrorInterceptor', function($log, $q, $cordovaToast, $rootScope, ENV, $injector, Storage){
    //TODO
    return {
      requestError: function(req){
        if(ENV.debug){
          // var url = req.config.url,
          //     status = req.status,
          //     error = req.data && req.data.error;
          // alert([status, error, url].join('-'));
          $log.error('requestError', req);
        }
        $rootScope.$broadcast('$HttpRequestError');
        return $q.reject(req);
      },
      responseError: function(res){
        if(res.status == 401){
          $rootScope.isAccess = false;
        }
        if(res.config.url.indexOf(ENV.uieApi) > -1&&res.status == 500&&res.data&&res.data.message=="Could not extract response: no suitable HttpMessageConverter found for response type [class java.util.HashMap] and content type [text/html;charset=UTF-8]"){
          //oa登录信息失效导致查询数据失败
          return $injector.get("UieLoginService").loginAndRetry(Storage.get('currentUser').telephone,res);
        }
        if(ENV.debug){
          // var url = res.config.url,
          //     status = res.status,
          //     error = res.data && res.data.error;
          // alert([status, error, url].join('-'));
          $log.error('responseError', res);
        }
        $rootScope.$broadcast('$HttpResponseError');
        return $q.reject(res);
      }
    };
  });
}();
