define(['attendanceRecord.boot'], function (require) {
  'use strict';

  var controller = angular.module('attendanceRecord.controllers');

  controller.controller('AttendanceRecordController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading, $interval, $ionicScrollDelegate, Storage, PersonnelService) {

    $scope.showNull = false;

    $scope.itemsAll = [
      {id: 0, place: '重庆', time: '2019-05-06 99:99:99', project: '设备加电'},
      {id: 1, place: '重庆', time: '2019-05-06 99:99:99', project: '设备加电'},
      {id: 2, place: '重庆', time: '2019-05-06 99:99:99', project: '设备加电'},
      {id: 3, place: '重庆', time: '2019-05-06 99:99:99', project: '设备加电'},
      {id: 4, place: '重庆', time: '2019-05-06 99:99:99', project: '设备加电'}
    ];
  });

  controller.controller('SignController', function (ENV,$stateParams, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, AttendanceRecordService,$ionicLoading, $interval, $ionicScrollDelegate, Storage, PersonnelService) {
    $scope.goBack = function () {
      $ionicHistory.goBack();
    };

    $scope.type = $stateParams.type || 1;
    $scope.projectTaskId = $stateParams.projectTaskId || '';

    $scope.showMsg = function (msg) {
      $ionicLoading.show({
        template: msg,
        noBackdrop: true,
        duration: 3000
      });
    };
    $ionicLoading.show({
      template: '定位中。。。',
      noBackdrop: true,
      duration: 10000
    });

    $scope.address = ''; //地址
    $scope.port = {};//经纬度
    var pointNow;  //初始化经纬度
    var mk;
    var circle;
    var map = new BMap.Map("container");  //map对象
    var geoc = new BMap.Geocoder();

    function handleMove(e) {
      //计算当前位置与考勤点距离
      var distance = map.getDistance(pointNow, e.point).toFixed(2);
      if (distance <= 1000) {
        mk.setPosition(e.point);
        getAddress(e.point)
      } else {
        $scope.showMsg('只能在1公里范围内签到');
        //不在范围内
        mk.setPosition($scope.port);
        getAddress($scope.port)
      }
    }

    //画圆
    function SetAttendance(point) {
      circle = new BMap.Circle(point, 1000, {
        fillColor: "blue",
        strokeWeight: 1,
        fillOpacity: 0.15,
        strokeOpacity: 0.1
      });// 显示签到点的位置（半径为1000米的一个圆）
      map.addOverlay(circle);
    }

    //根据port获取地址
    function getAddress(pt) {
      geoc.getLocation(pt, function(rs){
        $scope.port = pt;
        if (rs.surroundingPois && rs.surroundingPois.length){
          $scope.address  = rs.address + rs.surroundingPois[0].title
        }else {
          $scope.address =rs.address;
        }
        console.log('位置:'+$scope.address +',坐标:' + JSON.stringify($scope.port));
        $scope.$apply();
      });
    }
    document.addEventListener("deviceready", onDeviceReady, false);
    function onDeviceReady() {
      if ('baidumap_location' in window){
        baidumap_location.getCurrentPosition(function (res) {
          $ionicLoading.hide();
          console.log(res);
          pointNow = new BMap.Point(res.longitude, res.latitude);
          console.log(pointNow);
          getAddress(pointNow);
          map.centerAndZoom(pointNow, 15);
          mk = new BMap.Marker(pointNow);  //标注
          map.addOverlay(mk);
          mk.enableDragging();

          mk.addEventListener("dragend", function(e){
            handleMove(e)
          });
          map.addEventListener('click',function(e){
            handleMove(e)
          });
          SetAttendance(pointNow);
        }, function (error) {
          $scope.showMsg(error.describe)
          console.log(error);
        });
      }else {
        $ionicLoading.hide();
        console.error('baidumap_location is undefined');
      }
    }

    //签到
    $scope.sign = function () {
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      if ($scope.address == ''){
        $scope.showMsg('位置信息不能为空');
        $ionicLoading.hide()
        return
      }

      var parmas = {
        lat:$scope.port.lat,
        lng:$scope.port.lng,
        type:$scope.type,
        place:$scope.address,
        projectTaskId:$scope.projectTaskId,
        usertoken:Storage.get('userInfo').usertoken
      };
      AttendanceRecordService.doSignIn(parmas).success(function (res) {
        $scope.showMsg('签到成功');
        $timeout(function () {
          $ionicHistory.goBack()
        },1000)
      }).error(function (res) {
        if (res.errorCode == '000002') {
          var confirmPopup = $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function (res) {
            if (res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
      })
    }

  });

  return controller;
});
