define(['attendanceRecord.boot'], function(require){
  'use strict';

  var service = angular.module('attendanceRecord.services');
  service.factory('AttendanceRecordService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      doSignIn: function(data){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/signIn/doSignIn',
          dataType: "json",
          params:data
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
    };
  });
  return service;
});
