
define(['costManagement.boot'], function (require) {
  'use strict';
  var controller = angular.module('costManagement.controllers', ['ionic']);

  controller.controller('ReimbursementController', function (ENV, $scope, $controller, CostManagementService, Storage, $state, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal) {

    $scope.hasMore = false;
    $scope.noData = false;

    $scope.start = 0;
    $scope.limit = 15;
    $scope.currentType = 1;

    $scope.datalist = [];
    $scope.typeToggle = function (type) {
      $scope.datalist = [];
      $scope.currentType = type;
      $scope.onPullDown();
    };

    $scope.onPullDown = function () {
      $scope.datalist = [];
      $scope.start = 0;
      $scope.hasMore = false;
      $scope.loadMore();
    };

    $scope.loadMore = function () {
      var params = {
        limit:$scope.limit,
        start:$scope.start,
        type:$scope.currentType,
        usertoken: Storage.get("userInfo").usertoken
      };
      CostManagementService.getList(params).success(function (res) {
        if(res.success) {
          $scope.datalist = $scope.datalist.concat(res.record);
          $scope.start = $scope.start + res.record.length;
          res.record.length < $scope.limit ? $scope.hasMore = false : $scope.hasMore = true;
        }
        !$scope.datalist.length ? $scope.noData = true : $scope.noData = false;

        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');

      }).error(function (res) {
        if (res.errorCode == '000002') {
          var confirmPopup = $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function (res) {
            if (res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
      })
    };

    $scope.loadMore();

    $scope.gotoDetail = function (item) {
      $state.go('costManagement.RBDetail',{id:item.id,type:$scope.currentType})
    };

    $scope.$on('$ionicView.beforeEnter', function () {
      Storage.remove('costApprover');
    });

    $rootScope.$on('costListChanged',function () {
      $scope.onPullDown()
    });
  });
  controller.controller('addReimbursementController', function (ENV, $scope,$controller,CostManagementService, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading,$cordovaImagePicker,$ionicActionSheet, Storage, $state, $ionicScrollDelegate,$filter,$ionicHistory, $ionicModal) {
    $scope.imgs = [];
    $scope.data = {
      applyTime: '',
      applyReson: '',
      vehicle: '',

      longDistance: '',
      insideCity:'',
      hotelExpenses: '',
      cateringExpenses: '',
      travelExpenses: '',
      telephoneExpenses: '',
      offSiteSubsidy: '',
      vehicleOil: '',
      businessSupplies: '',
      roadToll: '',
      parkingToll: '',
      businessPromotionToll: '',
      expressToll: '',
      waterToll: '',
      electricToll: '',
      gasToll: '',
      vehicleLeasingToll: '',
      materialManagementToll: '',
      broadbandToll: '',
      leaseOfHousesToll: '',
      otherToll: '',
      otherTollReson: '',

      total: 0.00, //总计
      approver: '',
    };

    $scope.$on('$ionicView.beforeEnter', function () {
      $scope.costApprover = Storage.get('costApprover');
      if ($scope.costApprover != null) {
        $scope.data.approver = $scope.costApprover.id;
      }
    });

    $scope.$on('$ionicView.unloaded', function() {
      Storage.remove('costApprover');
    });

    // 更多
    $scope.hasOther = false;
    $scope.toggleMore = function () {
      $scope.hasOther = !$scope.hasOther;
      var top = $ionicScrollDelegate.$getByHandle('mainScroll').getScrollPosition().top;
      if($scope.hasOther === false){
        $timeout(function () {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBy(0, top);
        },100)
      }else {
        $ionicScrollDelegate.$getByHandle('mainScroll').resize();
      }
    };

    // 大图
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = item;
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, '', function (success) {
        }, function (error) {
        }
      );
    };

    // 日期选择
    var calendara = new datePicker2();
    var crruntData = $filter('date')(new Date(),'yyyy-MM-dd');

    $scope.selectToggle = function() {
        calendara.init({
          'trigger': '#projectId3',
          'type': 'date',
          'minDate': '2015-1-1',
          'maxDate':crruntData,
          'onSubmit':function(){
            $scope.data.applyTime = $filter('date')(calendara.value,'yyyy-MM-dd');
            $scope.$apply()
          },
          'onClose':function(){
          }

        });
    };

    // 交通工具选择
    $scope.selectData = [
      {name: '出租车', id:1 },
      {name: '公交车', id:2 },
      {name: '飞机', id:3 },
      {name: '火车', id:4 },
    ]
    $scope.showPopupVehicle = function () {
      var myPopupOne = $ionicPopup.show({
        template: '<div class="list">' +
        '<div  ng-repeat="item in selectData">' +
        '<ion-item class="mine-item" type="item-text-wrap" style="border-width: 0px;border-bottom-width: 1px;height:50px;margin:0px;text-align:center;" ng-click="chooseOK(item.id,item.name)">{{item.name}}</ion-item>' +
        '</div>' +
        '</div>',
        title: '请选择',
        scope: $scope,
        buttons: [
          {
            text: '<b>关闭</b>',
            type: 'button-assertive',
            onTap: function () {
              return false;
            }
          }
        ]
      });
      myPopupOne.then(function (res) {
        if (!res) {
          return false;
        } else {
          console.log('Tapped!');
        }
      });

      $scope.chooseOK = function (id, name) {
        $scope.data.vehicle = id;
        document.getElementById("vehicleVal").innerHTML = name;
        myPopupOne.close();
      };
    };

    //选择审批人
    $scope.chooserPerson = function () {
      $state.go('mailListGParent',{isChooserPerson:1});
    };

    //添加图片
    $scope.onAddPic = function () {
      if($scope.imgs.length >= 15) {
        $ionicLoading.show({
          template: '最多上传15张图片',
          noBackdrop: true,
          duration: 1000
        });
        return
      }
      $ionicActionSheet.show({
        buttons: [
          {text: '立即拍摄'},
          {text: '从相册中选择'}
        ],
        titleText: '请选择图片来源',
        cancelText: '返回',
        cancel: function () {
          $log.log('cancel');
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.onTakePhoto();  // 调用照相功能
              break;
            case 1:
              $scope.onAddFromAlbum();  // 调用选择图片功能
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //调用选择图片功能
    $scope.onAddFromAlbum = function () {
      var num = 15 - $scope.imgs.length;
      var options = {
        maximumImagesCount: num > 9? 9 : num, //需要显示的图片的数量
        width: 800,
        height: 800,
        quality: 100
      };
      $cordovaImagePicker.getPictures(options)
        .then(function (results) {
          if(Array.isArray(results)) {
            for (var i = 0; i < results.length; i++) {
              $scope.imgs.push(results[i]);
            }
            $scope.$apply();
          }
        }, function (error) {
          // error getting photos
        });
    };

    // 照相功能
    $scope.onTakePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        targetHeight: 450,
        targetWidth: 350
      };
      navigator.camera.getPicture(function (fileURL) {
          $scope.imgs.push(fileURL);
          $scope.$apply();
        },
        function () {//if error
        },
        options);
    };

    // 删除图片
    $scope.deleteImg = function (index) {
      var confirmPopup = $ionicPopup.confirm({
        title: '删除图片',
        template: '确定删除第' + (index + 1) + '张图片吗?',
        cancelText: '取消',
        okText: '确定',
        okType: 'button-assertive'
      });
      confirmPopup.then(function (res) {
        if (res) {
          $scope.imgs.splice(index, 1);
          $scope.$apply();
        } else {
          console.log('You are not sure');
        }
      });
    };

    //计算总费用
    var costTollUNQs = document.getElementsByClassName('costTollUNQ');
    for (var i = 0; i < costTollUNQs.length; i++){
      costTollUNQs[i].addEventListener('keyup', function (e) {
        calcToll();
      })
    }
    var calcToll = function () {
      $scope.data.total = 0.00;
      for (var i = 0; i < costTollUNQs.length; i++){
        if (costTollUNQs[i].value != ''){
          // 5位数，大于0，保留两位数
          if(!/^(([0-9]{0,5})|(([0]\.\d{1,2}|[1-9][0-9]{0,4}\.\d{1,2})))$/.test(Number(costTollUNQs[i].value))){
            $ionicLoading.show({
              template: '费用须小于5位数且最多两位小数',
              noBackdrop: true,
              duration: 1000
            });
            costTollUNQs[i].value = '';
          }
          $scope.data.total += Number(costTollUNQs[i].value);
        }
      }
      $scope.data.total = $scope.data.total.toFixed(2);
      $scope.$apply()
    };

    //上传图片
    $scope.upload = function (fileURL, troubleId, final) {
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
      if (options.fileName.indexOf('?') != -1) {
        options.fileName = options.fileName.substring(0, options.fileName.indexOf('?'));
      }
      options.mimeType = "image/jpeg";
      var params = {
        usertoken: Storage.get('userInfo').usertoken,
        tableId: troubleId,
        tableName: "cm_cost"
      };
      options.params = params;
      var ft = new FileTransfer();
      ft.upload(
        fileURL,
        encodeURI(ENV.api + "/cost/doUploadPic"),
        function () {
          if (final) {//如果是最后一张
            $timeout(function () {
              $ionicLoading.hide();
              $ionicHistory.goBack();
            }, 1000);
          }
        },
        function () {//失败
          console.log("图片上传失败");
          $ionicLoading.hide();
        },
        options
      );
    };

    //提交申请
    $scope.submit = function () {
      $ionicLoading.show();
      if($scope.data.applyTime === ''){
        $ionicLoading.show({
          template: '请选择费用日期',
          noBackdrop: true,
          duration: 800
        });
        return
      }
      if(Number($scope.data.total) === 0){
        $ionicLoading.show({
          template: '请填写报销金额',
          noBackdrop: true,
          duration: 800
        });
        return
      }
      if(Number($scope.data.total) < 0){
        $ionicLoading.show({
          template: '报销金额应大于0',
          noBackdrop: true,
          duration: 800
        });
        return
      }
      if($scope.data.approver === ''){
        $ionicLoading.show({
          template: '请选择审批人',
          noBackdrop: true,
          duration: 800
        });
        return
      }

      CostManagementService.saveCost($scope.data).success(function (res) {
        $rootScope.$emit('costListChanged');
        var imgArr = $scope.imgs;
        if (imgArr.length == 0) {// 没有图片
          $timeout(function () {
            $ionicLoading.hide();
            $ionicHistory.goBack();
          }, 1000);
        } else {// 有图片
          angular.forEach(imgArr, function (data, index, array) {
            //data等价于array[index]
            var fileURL = data;
            if (index == imgArr.length - 1) {  // 是否是最后一张
              $scope.upload(fileURL, res.record.entity.id, true);
            } else {
              $scope.upload(fileURL, res.record.entity.id, false);
            }
          });
        }
      }).error(function (res) {
        if (res.errorCode == '000002') {
          var confirmPopup = $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function (res) {
            if (res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
      })

    }

  });
  controller.controller('reimbursementDetailController', function (ENV, $scope,$controller,CostManagementService, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading,$cordovaImagePicker,$ionicActionSheet, Storage, $state, $ionicScrollDelegate,$filter, $ionicModal,$stateParams,$ionicHistory) {
    $scope.costId = $stateParams.id;
    $scope.type = $stateParams.type;
    $scope.msg = {
      approverStr: ''
    };
    CostManagementService.getDetail({costId:$scope.costId, usertoken: Storage.get("userInfo").usertoken}).success(function (res) {
      if (res.success){
        $scope.data = res.record;
      }
    }).error(function (res) {
      if (res.errorCode == '000002') {
        var confirmPopup = $ionicPopup.alert({
          title: '提示信息',
          template: '该帐号已在其他设备登录！',
          okText: '确定',
          okType: 'button-assertive'
        });
        confirmPopup.then(function (res) {
          if (res) {
            Storage.remove('isLogged');
            Storage.remove('userInfo');
            Storage.remove('menuList');
            $state.go('login');
          }
        });
      }
    })

    // 更多
    $scope.hasOther = false;
    $scope.toggleMore = function () {
      $scope.hasOther = !$scope.hasOther;
      var top = $ionicScrollDelegate.$getByHandle('mainScroll').getScrollPosition().top;
      if($scope.hasOther === false){
        $timeout(function () {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBy(0, top);
        },100)
      }else {
        $ionicScrollDelegate.$getByHandle('mainScroll').resize();
      }
    };

    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = '/file/getPic?id='+item.id+'&isCompress=false';
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, ENV.api, function (success) {
        }, function (error) {
        }
      );
    };

    $scope.approve = function (type) {
      $scope.msg.approverStr = '';
      if(type == 1){ //同意
        var confirmPopup = $ionicPopup.confirm({
          title: '提示',
          template: '确定通过该审批?',
          cancelText: '取消',
          okText: '确定',
          okType: 'button-assertive'
        });
        confirmPopup.then(function (res) {
          if (res) {
            $scope.doApprover(type)
          } else {
            console.log('You are not sure');
          }
        });
      }else {
        var shenhePopup = $ionicPopup.show({
          template: '<textarea ng-model="msg.approverStr" placeholder="请填写审批意见" maxlength="100" col="10" style="height: 100px;padding:5px;font-size: 13px;"></textarea>',
          title: '<strong>请填写审批意见</strong>',
          scope: $scope,
          buttons: [
            {
              text: '取消',
              onTap: function (e) {
                return false;
              }
            },
            {
              text: '<b>确定</b>',
              onTap: function (e) {
                if($scope.msg.approverStr == ''){
                  $ionicLoading.show({
                    template: '请填写审批意见',
                    noBackdrop: true,
                    duration: 800
                  });
                }else {
                  $scope.doApprover(type);
                }
              }
            }
          ]
        });
      }

    };

    $scope.doApprover = function (type) {
      $ionicLoading.show();
      CostManagementService.doApprover({
        costId:$scope.costId,
        applyStatus: type,
        approverStr: $scope.msg.approverStr,
        usertoken: Storage.get('userInfo').usertoken
      }).success(function (res) {
        $rootScope.$emit('costListChanged');
        if (res.success){
          $ionicLoading.show({
            template: '操作成功',
            noBackdrop: true,
            duration: 800
          });
          $ionicHistory.goBack();
        }else {
          $ionicLoading.show({
            template: '操作失败',
            noBackdrop: true,
            duration: 800
          });
        }
      }).error(function (res) {
        if (res.errorCode == '000002') {
          var confirmPopup = $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function (res) {
            if (res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
      })
    }

  });
  controller.filter('costVehicleType', function () {
    return function (type) {
      return {
        1:'出租车',
        2:'公交车',
        3:'飞机',
        4:'火车'
      }[type]||'';
    }
  });

  return controller;
});
