define(['costManagement.boot'], function(require){
  'use strict';

  var service = angular.module('costManagement.services');
  service.factory('CostManagementService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      //列表
      getList: function(data){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/cost/list',
          dataType: "json",
          params:data
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      //保存
      saveCost: function(data){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/cost/saveCost',
          headers: {'Content-Type': 'application/x-www-form-urlencoded'},
          transformRequest: function (obj) {
            var str = [];
            for (var p in obj) {
              str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
            }
            return str.join("&");
          },
          data:{
            cost:JSON.stringify(data),
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      // 详情
      getDetail: function(data){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/cost/getDetail',
          dataType: "json",
          params:data
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      // 审批
      doApprover: function(data){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/cost/doApprover',
          dataType: "json",
          params:data
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
    };
  });
  return service;
});
