/*
* @Author: HuangTiger
* @Date:   2017-06-01 15:46:57
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-07-21 17:33:34
*/

define(['middleware.boot'], function (require) {
  'use strict';


  var controller = angular.module('middleware.controllers', ['ionic']);
  controller.controller('MiddlewareController', function ($filter, ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $state, $stateParams, LocalDragon, Storage, MiddlewareService) {

    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
   var confirmPopup = null;
    $scope.usertoken = Storage.get('userInfo').usertoken;
    $scope.start = 0;
    $scope.limit = 15;
    $scope.taskList = [];
    $scope.showNull = false;
    $scope.sendType = $stateParams.type;
    console.log("$scope.sendType:", $scope.sendType);


  var today = new Date();
  $scope.todayDate = $filter('date')(today, 'yyyy-MM-dd');

  $scope.loadMore = function () {
    MiddlewareService.getProjectTask($scope.start, $scope.limit, $stateParams.id, $stateParams.type, $scope.usertoken)
    .success(function (data) {
        $ionicLoading.hide();
        if(data.taskList.length !== 0){

          var records = data.taskList;

          $scope.start = $scope.start + records.length;;
          $scope.taskList = $scope.taskList.concat(records);
          if(records.length >= $scope.limit){
            $scope.hasMore = true;
          } else{
            $scope.hasMore = false;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }else{
          $scope.hasMore = false;
        }
        $scope.showNull = !$scope.taskList.length > 0;
    }).error(function (data) {
        $ionicLoading.hide();
        //无数据
        $scope.showNull = !$scope.taskList.length > 0;
        if(data == null){
          $ionicLoading.show({
           template: "服务器异常，请稍后再试。",
           duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(confirmPopup==null){
           confirmPopup =  $ionicPopup.alert({
                 title: '提示信息',
                 template: '该帐号已在其他设备登录！',
                 okText: '确定',
                 okType: 'button-assertive'
               });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
        } else {
          $ionicLoading.show({
           template: data.msg,
           duration: 800
          });
        }
     });
  };

  $scope.loadMore();

  //一开始初始化的变量
  var relation = undefined, hDragon = null;

  var mask = undefined;
  var starText = undefined;
  var calendar = new datePicker();


	$scope.sDate = function(){

	//测试了9个插件后，还是用回原生插件

	  $timeout(function(){

		  calendar.init({
				'trigger': '#dateSelect',
				'type': 'date',
				'minDate':$scope.todayDate,
				'maxDate':'2100-12-31',
				'onSubmit':function(){
					var theSelectData=calendar.value;
				},
				/*取消时触发事件*/
				'onClose':function(){
				}
		  });
	  },0);

	}

  // 点击文字弹出框
  $scope.showPopupSue = function(node, magicBtn, extra, taskId, userId, startTime) {

  	  // $scope.data = {};
  	  console.log('node', node);

      // console.log('taskId', taskId);
      // console.log('userId', userId);

  	  //无法解决冒泡的问题，只能根据情况写逻辑判断，这里拿到的是每一列中的名字
  	  if (!extra) {

	  	  if (node.path[0].className === 'main-word-item') {

	  	  	relation = node.path[1].innerText.split(' ');

	  	  	relation = relation[1];

	  	  }else if (node.path[0].className === 'pull-right-aaa') {

	  	  	relation = node.path[0].innerText;
	  	  }else{

	  	  	relation = node.path[0].innerText.split(' ');

	  	  	relation = relation[1];
	  	  }
  	  }else{

  	  	relation = node;
  	  }

  	  if (magicBtn && node) {

  	  	//只在点击列表的时候启用本地缓存
  	  	LocalDragon.set('hDragon', relation);
  	  }

      if (relation == null || relation == '') {
        relation = "未分配"
      }

	  //调整任务人
	  $scope.editManage = function(){

	  	$state.go('middleware.manage', {"isBeing":"文明亮", "projectId" : $stateParams.id, "type" : $stateParams.type, "taskId" : taskId, "startTime" : $scope.dateSelect.today, "userId" : userId, "userName" : relation});
	  	myPopupOne.close();

	  }
    $scope.dateSelect = {
      today : startTime
    };
	  var myPopupOne = $ionicPopup.show({

		    template: '<div style="overflow:hidden;display: flex;justify-content: space-around;align-items: center"><span>任务执行人</span><span class="baseon-date-span"  ng-click="editManage()">'+
		    			relation +
		    			'</span></div>' +
		    			'<div style="overflow:hidden;display: flex;justify-content: space-around;align-items: center"><span>任务执行日期</span><span style="color:#1646c0;float:right;line-height: 34px;">'+
		    			// '<input type="text" class="form-control" uib-datepicker-popup ng-model="dt" is-open="popup2.opened" datepicker-options="dateOptions" ng-required="true" close-text="关闭" clear-text="清空" current-text="今天" previous-text="上一个" next-text="下一个" ng-click="open2()"/>' +
		    			'<input type = "text"  placeholder = "' + $scope.todayDate + '" id="dateSelect" ng-model="dateSelect.today" readonly="readonly"/>' +
		    			'</span></div>',
		    title : '任务安排详情',
		    scope: $scope,
		    buttons: [
		      { text: '取消',
		      	onTap: function(){
		      	}
		      },
		      {
		        text: '<b>确定</b>',
		        type: 'button-assertive',
		        onTap: function(e) {
              MiddlewareService.doSetProjectTask(taskId, userId, $scope.dateSelect.today, $scope.usertoken)
              .success(function (data) {
                  $state.go('middleware.details', {id : $stateParams.id, type : $stateParams.type, msgId : null}, {reload: true});
              }).error(function (data) {
                  if(data == null){
                    $ionicLoading.show({
                     template: "服务器异常，请稍后再试。",
                     duration: 800
                    });
                  } else if (data.errorCode == '000002') {
                    if(confirmPopup==null){
                     confirmPopup =  $ionicPopup.alert({
                           title: '提示信息',
                           template: '该帐号已在其他设备登录！',
                           okText: '确定',
                           okType: 'button-assertive'
                         });
                    confirmPopup.then(function(res) {
                      if(res) {
                        Storage.remove('isLogged');
                        Storage.remove('userInfo');
                        Storage.remove('menuList');
                        $state.go('login');
                      }
                    });
                  }
                  } else {
                    $ionicLoading.show({
                     template: data.msg,
                     duration: 800
                    });
                  }
               });
		        }
		      }
		    ]
	  });
  };

  	//点击⭐图标的弹出框
  	$scope.showPopupStar = function(node, type, id, name) {
      console.log('node--star:', node);
    //无法解决冒泡的问题，只能根据情况写逻辑判断，这里拿到的是每一列中的名字
    var nodeChild = null;
    if (node.path) {
      nodeChild = node.path[0];
    }else{

      nodeChild = node.srcElement;
    }
	  var nodeStar = nodeChild.className.split(' ');
	  nodeStar = nodeStar[1];
    if (nodeStar === 'ion-ios-star-outline') {
      mask = '关键';
      type = 2;
    }else if (nodeStar === 'ion-star') {
      mask = '普通';
      type = 1;
    }

	  var myPopupTwo = $ionicPopup.show({

		    template: '<div style="overflow:hidden;display: flex;justify-content: space-around"><span>任务执行人</span><span style="float:right;">'+
		    			name +
		    			'</span></div>' +
		    			'<div style="overflow:hidden;"><span>是否将该任务标记为'+ mask +'任务</span></div>',
		    title : '标记任务属性',
		    scope: $scope,
		    buttons: [
		      { text: '取消',
		      	onTap: function(){

		      		return false;
		      	}
		      },
		      {
		        text: '<b>确定</b>',
		        type: 'button-positive',
		        onTap: function(e) {
              MiddlewareService.doSetProjectTaskType(id, type, $scope.usertoken)
              .success(function (data) {
                //star类名变换
          			if (mask === '关键') {
          				nodeChild.className = 'icon ion-star';
          			}else{
          				nodeChild.className = 'icon ion-ios-star-outline';
          			}
              }).error(function (data) {
                  if(data == null){
                    $ionicLoading.show({
                     template: "服务器异常，请稍后再试。",
                     duration: 800
                    });
                  } else if (data.errorCode == '000002') {
                    if(confirmPopup==null){
                     confirmPopup =  $ionicPopup.alert({
                           title: '提示信息',
                           template: '该帐号已在其他设备登录！',
                           okText: '确定',
                           okType: 'button-assertive'
                         });
                    confirmPopup.then(function(res) {
                      if(res) {
                        Storage.remove('isLogged');
                        Storage.remove('userInfo');
                        Storage.remove('menuList');
                        $state.go('login');
                      }
                    });
                  }
                  } else {
                    $ionicLoading.show({
                     template: data.msg,
                     duration: 800
                    });
                  }
               });
		        }
		      }
		    ]
	  });
  	};


  	/*come here 2，这里主要是判断选择了哪个任务执行人*/
  	var msgId = $stateParams.msgId;
    // console.log('msgId', msgId);

    /*再次 启动ionicPopup*/
    if (msgId && msgId !== '我') {

      // console.log('msgId-back', '%'+msgId+'$');
    	$scope.showPopupSue(msgId, false, true, $stateParams.taskId, $stateParams.userId, $stateParams.startTime);

      $scope.sDate();

    }else if (msgId === '我'){

      var reHd = LocalDragon.get("hDragon");
      // console.log('reHd', reHd);
      $scope.showPopupSue(reHd, false, true, $stateParams.taskId, $stateParams.userId, $stateParams.startTime);
    }

  });
  //调整任务负责人
  controller.controller('ManageEditController', function (ENV, $scope, $ionicScrollDelegate, $log, $timeout,$rootScope, $ionicPopup, $ionicLoading, $ionicModal, $stateParams,  $cordovaKeyboard, $state, MiddlewareService, Storage) {

    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });

    $scope.keyboard = {show: false};
  	$scope.datalist=[];
    $scope.start = 0;
    $scope.limit =15;
    $scope.showNull = false;
    var confirmPopup = null;
    $scope.usertoken = Storage.get('userInfo').usertoken;
    $scope.manageList = [];
    $scope.cname="";
    $scope.loadMore = function () {
      MiddlewareService.getSameOrgPerson($scope.usertoken, $stateParams.taskId,$scope.cname,  $scope.start,$scope.limit)
      .success(function (data) {
          $ionicLoading.hide();
          if(data){
            var records = data.personList;
            $scope.start = $scope.start + records.length;;
            $scope.manageList = $scope.manageList.concat(records);
            if(records.length >= $scope.limit){
              $scope.hasMore = true;
            } else{
              $scope.hasMore = false;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }else{
            $scope.hasMore = false;
          }
          $scope.showNull = !$scope.manageList.length > 0;
      }).error(function (data) {
          $ionicLoading.hide();
          $scope.showNull = !$scope.manageList.length > 0;
          if(data == null){
            $ionicLoading.show({
             template: "服务器异常，请稍后再试。",
             duration: 800
            });
          } else if (data.errorCode == '000002') {
            if(confirmPopup==null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
          } else {
            $ionicLoading.show({
             template: data.msg,
             duration: 800
            });
          }
       });
    };

    $scope.loadMore();

    //处理名字 不是 '我' 之外的 '河粉'们
    $scope.hefen = function(man, id, name){
      $state.go('middleware.details', {id : $stateParams.projectId, type : $stateParams.type, msgId : name, taskId : $stateParams.taskId, startTime : $stateParams.startTime, userId : id});
      // console.log('man', man);
      // var manName = undefined;
      //
      // //纠正点击不能取到值的6种情况
      // if (man.path[0].localName === 'h2') {
      //
      //   manName = man.path[0].innerText;
      // }
      // if (man.path[0].innerText === '联系电话' && man.path[0].localName === 'span') {
      //
      //
      //   manName = man.path[1].previousElementSibling.innerText;
      // }
      //
      // if (man.path[0].className === 'list-num') {
      //
      //   manName = man.path[0].offsetParent.firstElementChild.nextElementSibling.innerText;
      // }
      //
      // if (man.path[0].localName === 'ion-item') {
      //
      //   manName = man.path[0].firstElementChild.nextSibling.innerText;
      // }
      // if (man.path[0].className === 'font-size-12' && man.path[0].localName === 'p') {
      //
      //   manName = man.path[0].offsetParent.firstElementChild.nextElementSibling.innerText;
      // }
      // if (man.path[0].localName === 'img') {
      //
      //   manName = man.path[0].nextElementSibling.innerText;
      // }
      //
      // //最后判断是否取到值，有则跳转
      // if (manName) {
      //
      //   $state.go('middleware.details', {id : 1, type : 'S', msgId : manName});
      // }
    }

    //下拉刷新
    $scope.onPullRefresh = function () {

          $scope.$broadcast('scroll.refreshComplete');
    };

    /*come here，这里主要是判断哪个账号点进来的，将人员管理里的名字改为---“我”*/
    var isBeing = $stateParams.isBeing;
    console.log('params', isBeing);


    $scope.goRevert = function () {
          $state.go('middleware.details', {id : $stateParams.projectId, type : $stateParams.type, msgId : $stateParams.userName, taskId : $stateParams.taskId, startTime : $stateParams.startTime, userId : $stateParams.userId});
    };

    $scope.todoSomething=function($event){
             if($event.keyCode==13){//回车

                 $scope.startDot();
             }
     }
     $scope.startDot = function() {//判断清除输入框的图标是否显示
      $cordovaKeyboard.close();
      $scope.start = 0;
      $scope.manageList = [];
      $scope.loadMore();
       $ionicScrollDelegate.scrollTop();
       if($scope.cname.length==0 || $scope.cname=="") {
           $scope.searchEmptyShow=false;
       }else{
           $scope.searchEmptyShow=true;
       }
     };


  });

  return controller;
});
