define(['personManage.boot'], function(require){
  'use strict';

  var service = angular.module('portal.services');
  service.factory('MiddlewareService', function($q, $http, $log, $base64, ENV) {
    return {
      //任务列表
      getProjectTask: function(pageStart, pageLimit, id, type, usertoken) {
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/arraygeTask/getProjectTask',
              dataType: "json",
              params: {
                usertoken : usertoken,
                projectId : id,
                type : type,
                start : pageStart,
                limit : pageLimit
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
    doSetProjectTaskType: function(taskId, taskType, usertoken) {
          var deferred = $q.defer(),
              promise = deferred.promise;
          $http({
            method: 'POST',
            url: ENV.api + '/arraygeTask/doSetProjectTaskType',
            dataType: "json",
            params: {
              usertoken : usertoken,
              taskId : taskId,
              taskType : taskType
            }
          }).success(function(res){
            if(res && res.success){
              deferred.resolve(res);
            } else {
              deferred.reject(res);
            }
          });

          promise.success = function(fn) {
              promise.then(fn);
              return promise;
          }
          promise.error = function(fn) {
              promise.then(null, fn);
              return promise;
          }
          return promise;
        },
  getSameOrgPerson: function(usertoken, taskId,cname,start,limit) {
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/arraygeTask/userListByTaskId',
          dataType: "json",
          params: {
            usertoken : usertoken,
            taskId : taskId,
            cname : cname,
            start : start,
            limit : limit
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
doSetProjectTask: function(taskId, executorUserId, executorDate, usertoken) {
      var deferred = $q.defer(),
          promise = deferred.promise;
      $http({
        method: 'POST',
        url: ENV.api + '/arraygeTask/doSetProjectTask',
        dataType: "json",
        params: {
          usertoken : usertoken,
          taskId : taskId,
          executorUserId : executorUserId,
          executorDate : executorDate
        }
      }).success(function(res){
        if(res && res.success){
          deferred.resolve(res);
        } else {
          deferred.reject(res);
        }
      });

      promise.success = function(fn) {
          promise.then(fn);
          return promise;
      }
      promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
      }
      return promise;
    }


    };
  });
  return service;
});
