/*
 * @Author: HuangTiger
 * @Date:   2017-06-11 00:44:30
 * @Last Modified by:   HuangTiger
 * @Last Modified time: 2017-07-21 17:49:25
 */

define(['performTask.boot'], function (require) {
  'use strict';


  var controller = angular.module('performTask.controllers', ['ionic', 'ion-datetime-picker']);

  //任务列表
  controller.controller('PerformTaskListController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $state, TodayTaskService, $stateParams, MiddlewareService,Storage,$ionicHistory,LocalDragon) {
    $scope.History = {
      goBack: function () {
        $scope.clearCache();
        $ionicHistory.goBack();
      }
    };
    $scope.projectId = $stateParams.projectId;
    $scope.projectSubId = $stateParams.projectSubId;
    //$scope.status = $stateParams.status;
    //$scope.type = $stateParams.type;

    $scope.status = null;
    $scope.type = null;

    $scope.start = 0;
    $scope.limit = 15;
    $scope.taskList = [];
    $scope.showNull = false;

    $scope.recordCache = function(){
      LocalDragon.set("todayTask_status",$scope.status);
      LocalDragon.set("todayTask_type",$scope.type);
    };
    $scope.clearCache = function(){
      LocalDragon.removeItem("todayTask_status");
      LocalDragon.removeItem("todayTask_type");
    };
    $scope.initCache = function(){
      console.log(null === undefined);
      $scope.status = getCatchValue(LocalDragon.get("todayTask_status")) === undefined ? 1 :getCatchValue(LocalDragon.get("todayTask_status"));
      $scope.type = getCatchValue(LocalDragon.get("todayTask_type")) === undefined ? null : getCatchValue(LocalDragon.get("todayTask_type"));
    };
    function getCatchValue(obj){
      if(obj == "null"){
        return null;
      }else{
        return obj;
      }
    }
    $scope.initCache();

    $scope.loadMore = function () {
      TodayTaskService.getTaskList($scope.start, $scope.limit, $scope.projectId, $scope.projectSubId,$scope.status,$scope.type)
        .success(function (data) {
          if (data.record.length !== 0) {
            //有数据
            $scope.showNull = false;
            var records = data.record;
            $scope.start = $scope.start + records.length;
            $scope.taskList = $scope.taskList.concat(records);
            if (records.length >= $scope.limit) {
              $scope.hasMore = true;
            } else {
              $scope.hasMore = false;
            }
          }else {
            $scope.hasMore = false;
          }
          if($scope.taskList.length == 0){
            $scope.showNull = true;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }).error(function (data) {
          //无数据
          if($scope.taskList.length == 0){
            $scope.showNull = true;
          }
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };
    $scope.loadMore();

    $scope.myClick = function(task){
      if(task.projectStatus == 4 || task.projectSubStatus == 2 || task.projectTaskStatus == 4){
        $state.go('personnelManagementFetails', {taskId: task.projectTaskId,name:task.projectTaskName,source:'app'}, {reload: true});
      }else{
        $state.go('performTask.details', {projectTaskId:task.projectTaskId,source:'app'});
      }
    };
    var mask = undefined;
    $scope.showPopupStar = function (node, type, id, name, num, indexS) {
      return;
      var nodeStar = node.path[0].className.split(' ');
      nodeStar = nodeStar[1];
      if (nodeStar === 'ion-ios-star-outline') {
        mask = '关键';
        type = 2;
      } else if (nodeStar === 'ion-star') {
        mask = '普通';
        type = 1;
      }
      $ionicPopup.show({
        template: '<div style="overflow:hidden;"><span>任务执行人</span><span style="float:right;">' +
        name +
        '</span></div>' +
        '<div style="overflow:hidden;"><span>是否将该任务标记为' + mask + '任务</span></div>',
        title: '标记任务属性',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            onTap: function () {
              return false;
            }
          },
          {
            text: '<b>确定</b>',
            type: 'button-assertive',
            onTap: function (e) {
              $ionicLoading.show({
                template: '提交中，请稍候...',
                noBackdrop: true
              });
              MiddlewareService.doSetProjectTaskType(id, type, Storage.get('userInfo').usertoken)
                .success(function (data) {
                  $ionicLoading.hide();
                  //star类名变换
                  if (mask === '关键') {
                    $scope.taskList[indexS].type = 2;
                    // node.path[0].className = 'icon ion-star';
                  } else {
                    $scope.taskList[indexS].type  = 1;
                    // node.path[0].className = 'icon ion-ios-star-outline';
                  }
                }).error(function (data) {
                  $ionicLoading.hide();
                  if (data == null) {
                    $ionicLoading.show({
                      template: "服务器异常，请稍后再试。",
                      duration: 800
                    });
                  } else if (data.errorCode == '000002') {
                    var confirmPopup =  $ionicPopup.alert({
                      title: '提示信息',
                      template: '该帐号已在其他设备登录！',
                      okText: '确定',
                      okType: 'button-assertive'
                    });
                    confirmPopup.then(function(res) {
                      if(res) {
                        Storage.remove('isLogged');
                        Storage.remove('userInfo');
                        Storage.remove('menuList');
                        $state.go('login');
                      }
                    });
                  } else {
                    $ionicLoading.show({
                      template: data.msg,
                      duration: 800
                    });
                  }
                });
            }
          }
        ]
      });
    };

    $scope.choiceType = function(str){
      $scope.type = str;
    };
    $scope.choicePState = function(str){
      $scope.status = str;
    };
    $scope.showPopupQuery = function(node) {
      console.log(1);
      var myPopupOne = $ionicPopup.show({

        template: '<div class="list">' +

        '<div class="item mine-item">' +
        '<div>任务类型</div>' +
        '<div >' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==null}" ng-click="choiceType(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==2}" ng-click="choiceType(2)">关键</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':type==1}" ng-click="choiceType(1)">普通</span></div>' +
        '</div>' +

        '<div class="item mine-item">' +
        '<div>任务状态</div>' +
        '<div >' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':status==null}" ng-click="choicePState(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':status==4}" ng-click="choicePState(4)">已完成</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':status==1}" ng-click="choicePState(1)">未完成</span></div>' +
        '</div>' +

        '</div>',
        title: '任务筛选',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            onTap: function () {
              $scope.initCache();
              return false;
            }
          },
          {
            text: '<b>确定</b>',
            type: 'button-positive',
            onTap: function (e) {
              $scope.recordCache();
              $scope.start = 0;
              $scope.taskList = [];
              $scope.loadMore();
              return false;
            }
          }
        ]
      });

      myPopupOne.then(function (res) {

        if (!res) {

          return false;
        } else {

          console.log('Tapped!');
          //TODO

        }

      });
    };

  });

  //任务明细
  controller.controller('PerformController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $state, $stateParams, $ionicHistory, PerformTaskService, $ionicSlideBoxDelegate, LocalDragon,Storage) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTask = null;
    $scope.projectTaskId = $stateParams.projectTaskId;
    $scope.source = $stateParams.source;
    $scope.dateValue = [];
    $scope.timeValue = [];
    $scope.selectModel = [];

    Date.prototype.format = function(format){
      var o = {
        "M+" : this.getMonth()+1, //month
        "d+" : this.getDate(), //day
        "h+" : this.getHours(), //hour
        "m+" : this.getMinutes(), //minute
        "s+" : this.getSeconds(), //second
        "q+" : Math.floor((this.getMonth()+3)/3), //quarter
        "S" : this.getMilliseconds() //millisecond
      }

      if(/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
      }

      for(var k in o) {
        if(new RegExp("("+ k +")").test(format)) {
          format = format.replace(RegExp.$1, RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length));
        }
      }
      return format;
    };
    $scope.init = function(){
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      PerformTaskService.getTaskDetail($scope.projectTaskId)
        .success(function (res) {
          $ionicLoading.hide();
          if (res && res.record) {
            $scope.projectTask = res.record;
            // 点击涉及按钮颜色变化
            $scope.someBlue = [];
            //点击 是/否 显示问题记录的变量
            $scope.shYes = [];
            $scope.shNo = [];
            for (var i = 0; i < $scope.projectTask.itemList.length; i++) {

              // 测试日期初始化
              var projectTaskItem = $scope.projectTask.itemList[i];
              if (projectTaskItem.status == 3) {//不涉及
                $scope.someBlue[i] = false;
              } else {//涉及
                $scope.someBlue[i] = true;
              }
              if (projectTaskItem.templateMode == 1) {
                var valueArr = projectTaskItem.templateModeValue.split(',');
                $scope.shYes[i] = false;
                $scope.shNo[i] = false;
                if (valueArr[0] == projectTaskItem.modeValue) {
                  $scope.shYes[i] = true;
                } else if (valueArr[1] == projectTaskItem.modeValue) {
                  $scope.shNo[i] = true;
                }
              }
              if(projectTaskItem.templateMode == 4){
                if(projectTaskItem.modeValue && projectTaskItem.modeValue != null && projectTaskItem.modeValue != ""){
                  $scope.dateValue[i] = new Date(projectTaskItem.modeValue.replace(/-/g,"/"));
                }else{
                  $scope.dateValue[i] = new Date();
                }

              }
              if(projectTaskItem.templateMode == 8){
                if(projectTaskItem.modeValue && projectTaskItem.modeValue != null && projectTaskItem.modeValue != ""){
                  $scope.timeValue[i] = new Date((projectTaskItem.modeValue).replace(/-/g,"/"));
                }else{
                  $scope.timeValue[i] = new Date();
                }
              }
            }
            $ionicSlideBoxDelegate.update();
          }
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };

    //初始化获取数据
    $scope.init();

    //提交部分的按钮颜色

    $scope.needRestart = false;
    $scope.overMan = false;
    //到问题登记页面
    $scope.comeRegistration = function (projectTaskItemId,type) {
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      if (projectTaskItemId && projectTaskItemId != null) {
        $state.go('performTask.registration', {
          projectTaskId: null,
          projectTaskItemId: projectTaskItemId,
          type:type
        }, {reload: true});
      } else {
        $state.go('performTask.registration', {
          projectTaskId: $scope.projectTaskId,
          projectTaskItemId: null,
          type:null
        }, {reload: true});
      }
    };

    //到问题列表
    $scope.comeTroubleList = function (projectTaskItemId, size) {
      if (size > 0) {
        $state.go('performTask.problemDetails', {projectTaskItemId: projectTaskItemId}, {reload: true});
      }
    };

    //工程量
    $scope.goProquantities = function () {
      $state.go('performTask.quantities',{projectId:$scope.projectTask.projectId, projectTaskId:$scope.projectTaskId}, {reload: true})
    }

    //签到
    $scope.goSign = function () {
      $state.go('sign',{type:2, projectTaskId:$scope.projectTaskId}, {reload: true})
    }

    //涉及--不涉及
    $scope.involve = function involve(type,projectTaskItemId,index){
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      PerformTaskService.doChangeTaskItemStatus(projectTaskItemId,type)
        .success(function (res) {
          $ionicLoading.hide();
          $scope.someBlue[index] = !$scope.someBlue[index];
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };

    //
    $scope.clickYesOrNo = function(item,index,mVal){
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      if(mVal == 1){
        $scope.shYes[index] = !$scope.shYes[index];
        $scope.doPerformInspection(item,index);
      }else if(mVal == 2){
        $scope.shNo[index] = !$scope.shNo[index];
        $scope.doPerformInspection(item,index,true);
      }else if(mVal == 3){
        $scope.shYes[index] = !$scope.shYes[index];
      }else if(mVal == 4){
        $scope.shNo[index] = !$scope.shNo[index];
      }
    };

    //执行任务
    $scope.doPerformInspection = function doPerformInspection(item,index,isGoTrouble){
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      var type = item.templateMode;
      var modeValue = "";
      if(type == 1){
        if(!$scope.shYes[index] && !$scope.shNo[index]){
          $scope.showAlert("请填写值");
          return;
        }
        if($scope.shYes[index]){
          modeValue = item.templateModeValue.split(',')[0];
        }else{
          modeValue = item.templateModeValue.split(',')[1];
        }
      }else if(type == 2){
        modeValue = document.getElementById("checkMode_"+index+"_2").value;
      }else if(type == 3){
        modeValue = document.getElementById("checkMode_"+index+"_3").value;
      }else if(type == 4){
        modeValue = $scope.dateValue[index].format("yyyy-MM-dd");
      }else if(type == 8){
        modeValue = $scope.timeValue[index].format("yyyy-MM-dd hh:mm:ss");
      }else{
        return;
      }
      if(modeValue == ""){
        $scope.showAlert("请填写值");
        return;
      }
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      PerformTaskService.doPerformInspection(item.id,modeValue)
        .success(function (res) {
          $timeout(function () {
            $ionicLoading.hide();
            if(isGoTrouble){
              $scope.comeRegistration(item.id,item.type);
            }else {
              $scope.init();
            }
          }, 500);
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };

    //完成任务
    $scope.doEndProjectTask = function doEndProjectTask(){
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      PerformTaskService.doEndProjectTask($scope.projectTask.id)
        .success(function (res) {
          $ionicLoading.hide();
          $timeout(function () {
            $scope.History.goBack();
          }, 1000);
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 3000
            });
          }
        });

    };

    //会签
    $scope.jointlySign = function (projectTaskItemId){
      if($scope.projectTask.status == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      $state.go('performTask.willSign', {
        projectTaskItemId: projectTaskItemId,
      }, {reload: true});
    };

      //图片预览
    $scope.bigImage = false;
    $scope.hideBigImage = function () {

      $scope.bigImage = false;
    };

    //点击图片放大
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = '/file/getPic?id='+item.id+'&isCompress=false';
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, ENV.api, function (success) {
        }, function (error) {
        }
      );
    };

    //用于返回当前页时定位
    $scope.detailsActive = LocalDragon.get("activeIndex_" + $scope.projectTaskId) || 0;
    $scope.findActive = function (activeNode) {
      $scope.detailsActive = activeNode;
      LocalDragon.set("activeIndex_" + $scope.projectTaskId, activeNode);
      //console.log('detailsActive', activeNode);
    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };
  });

  //作业指引
  controller.controller('PerformGuidanceController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, RiskWarningService, $stateParams, $state, $ionicHistory,$sce,Storage) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskId = $stateParams.projectTaskId;
    $scope.type = $stateParams.type;
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    RiskWarningService.getWorkMessage($scope.projectTaskId, $scope.type)
      .success(function (res) {
        $ionicLoading.hide();
        if (res && res.record) {
          $scope.item = $sce.trustAsHtml(res.record);
        }
      }).error(function (data) {
        $ionicLoading.hide();
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });
  });

  //问题登记
  controller.controller('PerformRegistrationController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, Storage, $ionicScrollDelegate, $stateParams, PerformTaskService, $state, $ionicActionSheet, $ionicHistory,$cordovaImagePicker) {
    $scope.keyboard = {show: false};
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskId = $stateParams.projectTaskId;
    $scope.projectTaskItemId = $stateParams.projectTaskItemId;

    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = item;
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, '', function (success) {
        }, function (error) {
        }
      );
    };

    $scope.formMessage = {
      projectTaskId: $scope.projectTaskId,
      projectTaskItemId: $scope.projectTaskItemId,
      type: null,
      level: null,
      company: null,
      status: null,
      violationType: null,
      violationItem: null,
      description: null,
      means: null
    };

    $scope.type = [];//问题类型
    $scope.level = [
      {id: 1, name: '重要'},
      {id: 2, name: '中等'},
      {id: 3, name: '一般'}
    ];//重要程度
    $scope.company = [];//责任单位
    $scope.status = [
      {id: 1, name: '未解决'},
      {id: 2, name: '已解决'},
      {id: 3, name: '遗留'}
    ];//问题状态
    $scope.violationType = [];//违规类型
    $scope.violationItem = [];//违规事项
    var singleConfirmPopup = null;
    PerformTaskService.getDictItem("TROUBLE_TYPE")
      .success(function (res) {
        if (res && res.record) {
          $scope.type = res.record;
          if($stateParams.type != "" && $stateParams.type != null){
            $scope.formMessage.type = $stateParams.type;
            for(var i = 0; i < $scope.type.length; i ++){
              if($scope.type[i].id == $scope.formMessage.type){
                document.getElementById("selectP0").innerHTML = $scope.type[i].name;
                return;
              }
            }
          }
        }
      }).error(function (data) {
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(singleConfirmPopup == null){
            singleConfirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            singleConfirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });
    PerformTaskService.getResponsibilityUnit($scope.projectTaskId, $stateParams.projectTaskItemId)
      .success(function (res) {
        if (res && res.record) {
          $scope.company = res.record;
        }
      }).error(function (data) {
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(singleConfirmPopup == null){
            singleConfirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            singleConfirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });
    PerformTaskService.getDictItem("VIOLATION_TYPE")
      .success(function (res) {
        if (res && res.record) {
          $scope.violationType = res.record;
        }
      }).error(function (data) {
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(singleConfirmPopup == null){
            singleConfirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            singleConfirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });

    $scope.selectData = [];
    // 确定
    $scope.clickSure = function () {
      if ($scope.formMessage.type == null) {
        $scope.showAlert("请选择问题类型");
        return;
      }
      if ($scope.formMessage.level == null) {
        $scope.showAlert("请选择重要程度");
        return;
      }
      if ($scope.formMessage.company == null) {
        $scope.showAlert("请选择责任单位");
        return;
      }
      if ($scope.formMessage.status == null) {
        $scope.showAlert("请选择任务状态");
        return;
      }
      if ($scope.isViolation.checked) {
        if ($scope.formMessage.violationType == null) {
          $scope.showAlert("请选择违规类型");
          return;
        }
        if ($scope.formMessage.violationItem == null) {
          $scope.showAlert("请选择违规事项");
          return;
        }
      }
      if ($scope.formMessage.description == null || $scope.formMessage.description == "") {
        $scope.showAlert("请填写问题描述");
        return;
      }
      if ($scope.formMessage.means == null || $scope.formMessage.means == "") {
        $scope.showAlert("请填写处理措施");
        return;
      }
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      PerformTaskService.doCreateTrouble($scope.formMessage)
        .success(function (res) {
          var imgArr = $scope.imgs;
          if (imgArr.length == 0) {// 没有图片
            $timeout(function () {
              $ionicLoading.hide();
              $scope.History.goBack();
            }, 1000);
          } else {// 有图片
            angular.forEach(imgArr, function (data, index, array) {
              //data等价于array[index]
              var fileURL = data;
              if (index == imgArr.length - 1) {  // 是否是最后一张
                $scope.upload(fileURL, res.record, true);
              } else {
                $scope.upload(fileURL, res.record, false);
              }
            });
          }
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });

    };
    // 是否违规
    $scope.isViolation = {checked: false};
    $scope.changeIsViolation = function () {
      $ionicScrollDelegate.resize();
      $scope.isShow = $scope.isViolation.checked;
      if (!$scope.isViolation.checked) {
        $scope.formMessage.violationType = null;
        $scope.formMessage.violationItem = null;
        document.getElementById("selectP4").innerHTML = "请选择";
        document.getElementById("selectP5").innerHTML = "请选择";
      }
    };
    $scope.showSelectWin = function (index) {
      $scope.indexNum = index;
      switch (index) {
        case 0://问题类型
          if($stateParams.type != "" && $stateParams.type != null){
            return;
          }
          $scope.selectData = $scope.type;
          $scope.showPopupSue(index);
          break;
        case 1://重要程度
          $scope.selectData = $scope.level;
          $scope.showPopupSue(index);
          break;
        case 2://责任单位
          $scope.selectData = $scope.company;
          $scope.showPopupSue(index);
          break;
        case 3://问题状态
          $scope.selectData = $scope.status;
          $scope.showPopupSue(index);
          break;
        case 4://问题状态
          $scope.selectData = $scope.violationType;
          $scope.showPopupSue(index);
          break;
        case 5://问题状态
          if ($scope.formMessage.violationType != null) {
            PerformTaskService.getDictItem($scope.formMessage.violationType)
              .success(function (res) {
                if (res && res.record) {
                  $scope.violationItem = res.record;
                  $scope.selectData = $scope.violationItem;
                  $scope.showPopupSue(index);
                }
              }).error(function (data) {
                if (data == null) {
                  $ionicLoading.show({
                    template: "服务器异常，请稍后再试。",
                    duration: 800
                  });
                } else if (data.errorCode == '000002') {
                  var confirmPopup =  $ionicPopup.alert({
                    title: '提示信息',
                    template: '该帐号已在其他设备登录！',
                    okText: '确定',
                    okType: 'button-assertive'
                  });
                  confirmPopup.then(function(res) {
                    if(res) {
                      Storage.remove('isLogged');
                      Storage.remove('userInfo');
                      Storage.remove('menuList');
                      $state.go('login');
                    }
                  });
                } else {
                  $ionicLoading.show({
                    template: data.msg,
                    duration: 800
                  });
                }
              });
          } else {
            $scope.selectData = $scope.violationItem;
            $scope.showPopupSue(index);
          }
          break;
        default:
          break;
      }

    };
    // 请选择
    $scope.showPopupSue = function (index) {
      $scope.nowIndex = index;
      $scope.chooseOK = function (id, name) {
        document.getElementById("selectP" + $scope.nowIndex).innerHTML = name;
        switch ($scope.nowIndex) {
          case 0://问题类型
            $scope.formMessage.type = id;
            break;
          case 1://重要程度
            $scope.formMessage.level = id;
            break;
          case 2://责任单位
            $scope.formMessage.company = id;
            break;
          case 3://问题状态
            $scope.formMessage.status = id;
            break;
          case 4://问题状态
            $scope.formMessage.violationType = id;
            $scope.formMessage.violationItem = null;
            document.getElementById("selectP5").innerHTML = "请选择";
            break;
          case 5://问题状态
            $scope.formMessage.violationItem = id;
            break;
          default:
            break;
        }
        myPopupOne.close();
      };
      var myPopupOne = $ionicPopup.show({
        template: '<div class="list">' +
        '<div  ng-repeat="item in selectData">' +
        '<ion-item class="mine-item" type="item-text-wrap" style="border-width: 0px;border-bottom-width: 1px;height:50px;margin:0px;text-align:center;" ng-click="chooseOK(item.id,item.name)">{{item.name}}</ion-item>' +
        '</div>' +
        '</div>',
        title: '请选择',
        scope: $scope,
        buttons: [
          {
            text: '<b>关闭</b>',
            type: 'button-assertive',
            onTap: function () {
              return false;
            }
          }
        ]
      });
      myPopupOne.then(function (res) {
        if (!res) {
          return false;
        } else {
          console.log('Tapped!');
        }
      });
    };
    //图片上传
    $scope.imgs = [];
    $scope.onAddPic = function () {
      //if ($scope.imgs.length >= 9) {
      //  $scope.showAlert("上传图片数量上限");
      //  return;
      //}
      $ionicActionSheet.show({
        buttons: [
          {text: '立即拍摄'},
          {text: '从相册中选择'}
        ],
        titleText: '请选择图片来源',
        cancelText: '返回',
        cancel: function () {
          $log.log('cancel');
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.onTakePhoto();  // 调用照相功能
              break;
            case 1:
              $scope.onAddFromAlbum();  // 调用选择图片功能
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //$scope.onAddFromAlbum = function () {
    //  var options = {
    //    quality: 100,
    //    destinationType: Camera.DestinationType.FILE_URI,
    //    sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
    //    encodingType: Camera.EncodingType.JPEG,
    //    mediaType: Camera.MediaType.PICTURE,
    //    targetHeight: 450,
    //    targetWidth: 350
    //  };
    //  navigator.camera.getPicture(function (fileURL) {
    //      $scope.imgs.push(fileURL);   // 向数组的末尾添加一个或多个元素，并返回新的长度。
    //      $scope.$apply();  // 如果你在AngularJS上下文之外的任何地方修改了model，那么你就需要通过手动调用$apply()来通知AngularJS
    //    },
    //    function () {//if error
    //    },
    //    options);
    //};
    $scope.onAddFromAlbum = function () {
      var options = {
        maximumImagesCount: 9, //需要显示的图片的数量
        width: 800,
        height: 800,
        quality: 100
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (results) {
          if(Array.isArray(results)) {
            for (var i = 0; i < results.length; i++) {
              console.log(results);
              $scope.imgs.push(results[i]);
            }
            $scope.$apply();
          }
        }, function(error) {
          // error getting photos
        });

    };
    // 照相功能
    $scope.onTakePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        targetHeight: 450,
        targetWidth: 350
      };
      navigator.camera.getPicture(function (fileURL) {
          $scope.imgs.push(fileURL);
          $scope.$apply();
        },
        function () {//if error
        },
        options);
    };

    // 删除图片
    $scope.deleteImg = function (index) {
      var confirmPopup = $ionicPopup.confirm({
        title: '删除图片',
        template: '确定删除第' + (index + 1) + '张图片吗?',
        cancelText: '取消',
        okText: '确定',
        okType: 'button-assertive'
      });
      confirmPopup.then(function (res) {
        if (res) {
          $scope.imgs.splice(index, 1);
          $scope.$apply();
        } else {
          console.log('You are not sure');
        }
      });
    };
    $scope.upload = function (fileURL, troubleId, final) {
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
      if(options.fileName.indexOf('?') != -1){
        options.fileName = options.fileName.substring(0,options.fileName.indexOf('?'));
      }
      options.mimeType = "image/jpeg";
      var params = {
        usertoken: Storage.get('userInfo').usertoken,
        tableId: troubleId,
        tableName: "cm_project_task_trouble",
        fileSource: 2,
        category: 4
      };
      options.params = params;
      var ft = new FileTransfer();
      ft.upload(
        fileURL,
        encodeURI(ENV.api + "/trouble/doUploadPic"),
        function () {
          if (final) {//如果是最后一张
            $timeout(function () {
              $ionicLoading.hide();
              $scope.History.goBack();
            }, 1000);
          }
        },
        function () {//失败
          console.log("图片上传失败");
          $ionicLoading.hide();
        },
        options
      );
    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };

  });

  //图片上传页面
  controller.controller('PerformPictureController', function (ENV, $scope, $ionicActionSheet, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $stateParams, PerformTaskService, $state, $ionicHistory, Storage,$cordovaImagePicker) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskItemEventId = $stateParams.projectTaskItemEventId;
    $scope.poText = $stateParams.poText;
    $scope.modeValue = $stateParams.modeValue;
    $scope.projectStatus = $stateParams.status;
    $scope.bigImage = false;
    $scope.hideBigImage = function () {
      $scope.bigImage = false;
    };
    //点击图片放大
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        if (item.type == 2){
          o.picUrl = item.url;
        }
        if(item.type == 1){
          o.picUrl = ENV.api+'/file/getPic?id='+item.url+'&isCompress=false';
        }
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, '', function (success) {
        }, function (error) {
        }
      );
    };
    // $scope.shouBigImage = function (imageName) {  //传递一个参数（图片的URl）
    //   $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    //   console.log($scope.Url);
    //   $scope.bigImage = true;                   //显示大图
    // };

    $scope.imgs = [];
    $scope.delImgs = [];
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    PerformTaskService.getAttachmentList($scope.projectTaskItemEventId, 'cm_project_task_item_event', 'image', 3)
      .success(function (res) {
        $ionicLoading.hide();
        if (res && res.record) {
          var data = res.record;
          if (data.length > 0) {
            for (var i = 0; i < data.length; i++) {
              $scope.imgs.push({url:data[i].id,type:1});
            }
          }
        }
      }).error(function (data) {
        $ionicLoading.hide();
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });

    $scope.clickSure = function () {
      if($scope.projectStatus == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      var imgArr = [];
      for (var i = 0; i < $scope.imgs.length; i++) {
        var item = $scope.imgs[i];
        if (item.type == 2) {
          imgArr.push(item);
        }
      }
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      if (imgArr.length == 0) {// 没有图片
        $scope.deleteProjectTaskItemEventImg();
      } else {// 有图片
        $scope.upload(imgArr, $scope.projectTaskItemEventId,0);
        /*angular.forEach(imgArr, function (data, index, array) {
          //data等价于array[index]
          var fileURL = data.url;
          if (index == imgArr.length - 1) {  // 是否是最后一张
            $scope.upload(fileURL, $scope.projectTaskItemEventId, true);
          } else {
            $scope.upload(fileURL, $scope.projectTaskItemEventId, false);
          }
        });*/
      }
    };

    $scope.deleteProjectTaskItemEventImg = function () {
      if ($scope.delImgs.length > 0) {
        PerformTaskService.deletePic($scope.delImgs.join(","), $scope.projectTaskItemEventId)
          .success(function (res) {
            $timeout(function () {
              $ionicLoading.hide();
              $scope.History.goBack();
            }, 1000);
          }).error(function (data) {
            $ionicLoading.hide();
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });

      } else {
        $timeout(function () {
          $ionicLoading.hide();
          $scope.History.goBack();
        }, 1000);
      }
    };
    // 图片点击+ 触发此事件

    $scope.onAddPic = function () {
      if($scope.projectStatus == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      //if ($scope.imgs.length >= 9) {
      //  $scope.showAlert("上传图片数量上限");
      //  return;
      //}
      $ionicActionSheet.show({
        buttons: [
          {text: '立即拍摄'},
          {text: '从相册中选择'}
        ],
        titleText: '请选择图片来源',
        cancelText: '返回',
        cancel: function () {
          $log.log('cancel');
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.onTakePhoto();  // 调用照相功能
              break;
            case 1:
              $scope.onAddFromAlbum();  // 调用选择图片功能
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //$scope.onAddFromAlbum = function () {
    //  var options = {
    //    quality: 100,
    //    destinationType: Camera.DestinationType.FILE_URI,
    //    sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
    //    encodingType: Camera.EncodingType.JPEG,
    //    mediaType: Camera.MediaType.PICTURE,
    //    targetHeight: 450,
    //    targetWidth: 350
    //  };
    //  navigator.camera.getPicture(function (fileURL) {
    //      $scope.imgs.push({url:fileURL,type:2});   // 向数组的末尾添加一个或多个元素，并返回新的长度。
    //      $scope.$apply();  // 如果你在AngularJS上下文之外的任何地方修改了model，那么你就需要通过手动调用$apply()来通知AngularJS
    //    },
    //    function () {//if error
    //    },
    //    options);
    //};

    $scope.onAddFromAlbum = function () {
      var options = {
        maximumImagesCount: 9, //需要显示的图片的数量
        width: 800,
        height: 800,
        quality: 100
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (results) {
          if(Array.isArray(results)) {
            for (var i = 0; i < results.length; i++) {
              var o ={url:results[i],type:2};
              $scope.imgs.push(o);
            }
            $scope.$apply();
          }
        }, function (error) {
          // error getting photos
        });
    };


    // 照相功能
    $scope.onTakePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        targetHeight: 450,
        targetWidth: 350
      };
      navigator.camera.getPicture(function (fileURL) {
          $scope.imgs.push({url:fileURL,type:2});
          $scope.$apply();
        },
        function () {//if error
        },
        options);
    };

    // 删除图片
    $scope.deleteImg = function (index) {
      if($scope.projectStatus == 4){
        $scope.showAlert("任务已完成!");
        return;
      }
      var confirmPopup = $ionicPopup.confirm({
        title: '删除图片',
        template: '确定删除第' + (index + 1) + '张图片吗?',
        cancelText: '取消',
        okText: '确定',
        okType: 'button-assertive'
      });
      confirmPopup.then(function (res) {
        if (res) {
          var item = $scope.imgs[index];
          if (item.type == 1) {
            $scope.delImgs.push(item.url);
          }
          $scope.imgs.splice(index, 1);
          $scope.$apply();
        } else {
          console.log('You are not sure');
        }
      });
    };
    $scope.upload = function (imgArr, projectTaskItemEventId,index) {
      if(index == imgArr.length){
        $scope.deleteProjectTaskItemEventImg();
        return;
      }
      var fileURL = imgArr[index].url;
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
      if(options.fileName.indexOf('?') != -1){
        options.fileName = options.fileName.substring(0,options.fileName.indexOf('?'));
      }
      options.mimeType = "image/jpeg";
      var params = {
        usertoken: Storage.get('userInfo').usertoken,
        tableId: projectTaskItemEventId,
        tableName: "cm_project_task_item_event",
        fileSource: 4,
        category: 3
      };
      options.params = params;
      var ft = new FileTransfer();
      ft.upload(
        fileURL,
        encodeURI(ENV.api + "/todayTask/doExecutableFileUpload"),
        function () {
          index = index + 1;
          $scope.upload(imgArr,projectTaskItemEventId,index);
        },
        function () {//失败
          index = index + 1;
          $scope.upload(imgArr,projectTaskItemEventId,index);
        },
        options
      );
    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };

  });

  //问题列表，跳转的是 同一个问题详情
  controller.controller('PerformProblemController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, PerformTaskService, $ionicHistory, $stateParams, $state,Storage) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskItemId = $stateParams.projectTaskItemId;
    $scope.datalist = [];
    $scope.start = 0;
    $scope.limit = 15;
    $scope.showNull = false;
    $scope.proSup = [];
    //下拉刷新
    $scope.onPullRefresh = function () {
      $scope.$broadcast('scroll.refreshComplete');
    };

    $scope.loadMore = function () {
      PerformTaskService.getTroubleList($scope.start, $scope.limit, $scope.projectTaskItemId)
        .success(function (res) {
          if (res && res.record.length !== 0) {
            //有数据
            $scope.showNull = false;

            var records = res.record;
            $scope.start = $scope.start + records.length;
            $scope.datalist = $scope.datalist.concat(records);

            //点击问题title可以收起
            for(var it in $scope.datalist){

              $scope.proSup[$scope.datalist[it].projectId] = false;
            }
            if (records.length >= $scope.limit) {
              $scope.hasMore = true;
            } else {
              $scope.hasMore = false;
            }
          }else {
            $scope.hasMore = false;
          }
          if($scope.datalist.length == 0){
            $scope.showNull = true;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }).error(function (data) {
          //无数据
          if($scope.datalist.length == 0){
            $scope.showNull = true;
          }

          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };
    $scope.loadMore();
  });

  //下载列表
  controller.controller('PerformDownloadListController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $ionicHistory, $stateParams, PerformTaskService, $state, $cordovaDevice, $cordovaFileTransfer, $cordovaFileOpener2, $cordovaToast, Storage) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskItemId = $stateParams.projectTaskItemId;
    $scope.projectTaskItemEventId = $stateParams.projectTaskItemEventId;

    $scope.options = {
      usertoken: Storage.get('userInfo').usertoken,
      projectTaskItemId: $scope.projectTaskItemId,
      projectTaskItemEventId:$scope.projectTaskItemEventId
    };
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    PerformTaskService.getDownloadList($scope.options)
      .success(function (res) {
        $ionicLoading.hide();
        if (res && res.record) {
          $scope.downList = res.record;
        }
      }).error(function (data) {
        $ionicLoading.hide();
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });

    $scope.download = function (attachmentId, attachmentName) {
      var base = ENV.api + "/todayTask/doDownloadFile?id="+attachmentId+"&usertoken="+$scope.options.usertoken
        +"&projectTaskItemId="+$scope.options.projectTaskItemId+"&projectTaskItemEventId="+$scope.options.projectTaskItemEventId;
      $ionicPopup.confirm({
        title: '下载提示',
        template: '确认下载吗？',
        buttons: [{
          text: '取消',
          type: 'button-default',
          onTap: function (e) {
            // 当点击时，e.preventDefault() 会阻止弹窗关闭。
          }
        }, {
          text: '确认',
          type: 'button-assertive',
          onTap: function (e) {
            var url = base,
              targetDir = cordova.file.externalDataDirectory || cordova.file.dataDirectory,
              targetPath = targetDir + attachmentName,
              trustHosts = true,
              platform;
            if (window.device) {
              platform = $cordovaDevice.getPlatform();
            }
            $ionicLoading.show({
              template: '正在下载, 请稍候...',
              noBackdrop: true
            });
              $cordovaFileTransfer.download(url, encodeURI(targetPath), {}, trustHosts).then(function (result) {
                $ionicLoading.hide();
                $ionicPopup.confirm({
                  title: '提示信息',
                  template: '文件下载成功, 打开文件需安装文档查看应用(如:WPS).<br/>保存位置: <br/>' + targetPath,
                  cancelText: '关闭',
                  okText: '立即打开'
                }).then(function (res) {
                  var ldot = targetPath.lastIndexOf(".");
                  var type = targetPath.substring(ldot + 1);
                  if (res) {
                    if (platform === 'iOS') {
                      if (type == 'png') {
                        $cordovaFileOpener2.open(encodeURI(targetPath), 'image/png');
                      } else if (type == 'bmp') {
                        $cordovaFileOpener2.open(encodeURI(targetPath), 'image/bmp');
                      } else if (type == 'jpe' || type == 'jpeg' || type == 'jpg') {
                        $cordovaFileOpener2.open(encodeURI(targetPath), 'image/jpeg');
                      } else {
                        $cordovaFileOpener2.open(encodeURI(targetPath), 'application/pdf');
                      }
                    } else {
                      if (type == 'png') {
                        $cordovaFileOpener2.open(targetPath, 'image/png');
                      } else if (type == 'bmp') {
                        $cordovaFileOpener2.open(targetPath, 'image/bmp');
                      } else if (type == 'jpe' || type == 'jpeg' || type == 'jpg') {
                        $cordovaFileOpener2.open(targetPath, 'image/jpeg');
                      } else {
                        $cordovaFileOpener2.open(targetPath, 'application/pdf').then(function () {
                        }, function (err) {
                        });
                      }
                    }
                  }
                });
              }, function (err) {
                $log.error('文件下载失败', err);
                $ionicLoading.hide();
                $cordovaToast.showShortBottom("文件下载失败");
              }, function (progress) {
              });
          }
        }]
      });
    };

  });

  //会签
  controller.controller('PerformWillSignController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $ionicHistory, $stateParams,PerformTaskService,$state,Storage) {

    $scope.goBack = function () {
      $ionicHistory.goBack();
    };

    $scope.projectTaskItemId = $stateParams.projectTaskItemId;

    //请看我的表演
    var paint, drawingAreaX, drawingAreaY, drawingAreaWidth, drawingAreaHeight;
    var clickX = [],
        clickY = [],
        clickDrag = [];
    var curSize = "normal";
    var radius, mouseX, mouseY;

    // 画布对象
    var canvas;
    var context;


      canvas = document.createElement("canvas");
      canvas.width = window.innerWidth;
      canvas.height = window.innerHeight - 100;
      canvas.id = "canvas";
      context = canvas.getContext('2d');
      document.getElementById('sign-area').appendChild(canvas);


    var drawBorder = function() {

        context.beginPath();
        context.rect(0, 0, canvas.width, canvas.height);
        context.closePath();
        context.fillStyle = '#e1272a';
        context.fill();
        context.beginPath();
        context.rect(2, 2, canvas.width - 4, canvas.height - 4);
        context.closePath();
        context.fillStyle = 'white';
        context.fill();
    };

    var redraw = function() {
        // clearCanvas();

        context.save();
        context.beginPath();
        context.rect(0, 0, drawingAreaWidth, drawingAreaHeight);
        context.clip();

        // 每个点
        for (var i = 0; i < clickX.length; i += 1) {

            radius = 2;

            // 设置画笔路径
            context.beginPath();
            // 两点之间的连线
            if (clickDrag[i] && i) {
                context.moveTo(clickX[i - 1], clickY[i - 1] - 50);
            } else {
                // The x position is moved over one pixel so a circle even if not dragging
                context.moveTo(clickX[i] - 1, clickY[i] - 50);
            }
            context.lineTo(clickX[i], clickY[i] - 50);

            context.strokeStyle = "black";
            context.lineCap = "round";
            context.lineJoin = "round";
            context.lineWidth = radius;
            context.stroke();
        }
        context.closePath();
        //context.globalCompositeOperation = "source-over";// To erase instead of draw over with white
        context.restore();


        context.globalAlpha = 1; // 不支持微软以及诺基亚手机

    };


    var clearArray = function(arr) {
        while (arr.length > 0) {
            arr.pop();
        }
    };

    var addClick = function(x, y, dragging) {

        clickX.push(x);
        clickY.push(y);
        clickDrag.push(dragging);
    };

    var createEvents = function() {
        var press = function(e) {
            console.log('e.pageY:', mouseY);
            // e.preventDefault();
            mouseX = e.pageX; //- this.offsetLeft,
            mouseY = e.pageY; // - this.offsetTop;
            paint = true;
            addClick(mouseX, mouseY, false);
            redraw();
        },

        drag = function(e) {
          // e.preventDefault();
            if (paint) {
                addClick(e.pageX, e.pageY, true);
                redraw();
            }
        },

        release = function() {
            paint = false;
            redraw();
        },

        cancel = function() {
            paint = false;
        },
        touchPress = function(e) {
          e.preventDefault();
            press(e.targetTouches[0]);
        },
        touchDrag = function(e) {
          e.preventDefault();
            drag(e.targetTouches[0]);
        };

        // 鼠标点击事件，兼容个别微软手机
        // canvas.addEventListener("mousedown", press, false);
        // canvas.addEventListener("mousemove", drag, false);
        // canvas.addEventListener("mouseup", release);
        // canvas.addEventListener("mouseout", cancel, false);

        // 标准移动端监听事件
        canvas.addEventListener("touchstart", touchPress, false);
        canvas.addEventListener("touchmove", touchDrag, false);
        canvas.addEventListener("touchend", release, false);
        canvas.addEventListener("touchcancel", cancel, false);
    };

    //表演开始
    createEvents();
    drawingAreaWidth = canvas.width;
    drawingAreaHeight = canvas.height;
    drawBorder();

    // 重画
    $scope.rewrite = function () {

      context.clearRect(0, 0, canvas.width, canvas.height);
      drawBorder();
      clearArray(clickDrag);
      clearArray(clickX);
      clearArray(clickY);
    };

    $scope.dataURLtoBlob = function (dataurl) {
      var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
      while(n--){
        u8arr[n] = bstr.charCodeAt(n);
      }
      return new Blob([u8arr], {type:mime});
    };

    //变成图片
    $scope.convertCanvasToImage = function () {
      var dataurl = canvas.toDataURL('image/png');
      var blob = $scope.dataURLtoBlob(dataurl);
//使用ajax发送
      var formMan = new FormData();
      formMan.append("file", blob,"image.jpeg");
      formMan.append("usertoken", Storage.get('userInfo').usertoken);
      formMan.append("tableId", $scope.projectTaskItemId);
      formMan.append("tableName", "cm_project_task_item");
      formMan.append("fileSource", 3);
      formMan.append("category", 3);
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = state_Change;
      xhr.open("post",ENV.api + '/todayTask/doExecutableFileUploadBase64');
      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      xhr.send(formMan);
      function state_Change(){
        $ionicLoading.hide();
        if (xhr.readyState == 4){// 4 = "loaded"
          if (xhr.status==200){// 200 = "OK"
            var res = eval("(" + xhr.responseText + ")");
            if(res.success){
              $timeout(function () {
                $scope.goBack();
              }, 2000);
            }else{
              $scope.showAlert(res.msg);
            }
          }else{
            console.log('fail');
          }
        }
      }

    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };
  });

  //工程量
  controller.controller('PerformQuantitiesController',function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $ionicHistory, $stateParams, PerformTaskService, $state, $cordovaDevice, $cordovaFileTransfer, $cordovaFileOpener2, $cordovaToast, Storage) {
      $scope.goBack = function () {
        $ionicHistory.goBack();
      };
      $scope.noData = false;
      $scope.projectId = $stateParams.projectId;  //项目id
      $scope.projectTaskId = $stateParams.projectTaskId; //任务id
      $scope.form = {name: ''};
      $scope.dataList = [];
      $scope.copyData = [];

      $scope.toggleSearchBar = function () {
        $scope.showSearch = !$scope.showSearch;
      };

      $scope.showMsg = function (msg) {
        $ionicLoading.show({
          template: msg,
          noBackdrop: true,
          duration: 3000
        });
      };

      $scope.getList = function () {
        $ionicLoading.show({
          template: '加载中...',
          noBackdrop: true
        });
        PerformTaskService.getProjectMaterials($scope.projectId,$scope.form.name,$scope.projectTaskId).success(function (res) {
          $ionicLoading.hide()
          if (res.record.length === 0){
            $scope.noData = true;
          }else {
            $scope.noData = false;
          }
          $scope.copyData = angular.copy(res.record);
          $scope.copyData.forEach(function (item) {
            item['_log'] = item['logNum'];
          })
          $scope.dataList = $scope.copyData;
        }).error(function (erro) {
          $scope.showMsg('加载失败，请稍后重试')
        })
      };

      // 搜索
      $scope.search = function () {
        if ($scope.form.name === '') {
          $scope.dataList = $scope.copyData;
        }else {
          var arr = [];
          for (var i =0; i<$scope.copyData.length; i++) {
            if ($scope.copyData[i]['name'].indexOf($scope.form.name) !== -1){
              arr.push($scope.copyData[i]);
            }else if($scope.copyData[i]['specification'].indexOf($scope.form.name) !== -1){
              arr.push($scope.copyData[i]);
            }
          }
          $scope.dataList = arr;
        }
        if ($scope.dataList.length === 0){
          $scope.noData = true;
        }else {
          $scope.noData = false;
        }
      };

      //输入框change
      $scope.inputChange = function (e) {

        if(/^(([1-9]\d*|0)|(([0]\.\d{1,2}|[1-9][0-9]*\.\d{1,2})))$/.test(e.logNum)){ //正数0+两位小数
          // 一开始输入的数量因其他任务完成而剩余量不足
          if (e._log > (e.quantity-e.useQuantity)){
            if(e.logNum > (e.quantity-e.useQuantity)) {
              $scope.showMsg('完成数量不能大于剩余数量');
            }
          }else {
            if(e.logNum> (e.quantity-e.useQuantity)) {
              e.logNum = e._log;
              $scope.showMsg('完成数量不能大于剩余数量');
            }
          }
        }else if (e.logNum == null){
          e.logNum = ''
        }else {
          e.logNum = e._log
        }
      };

      //保存
      $scope.save = function () {
        $ionicLoading.show({
          template: '提交中，请稍候...',
          noBackdrop: true
        });
        console.log($scope.copyData)
        var arr = [];
        for(var i = 0 ;i<$scope.copyData.length; i++){
          if ($scope.copyData[i].logNum > ( $scope.copyData[i].quantity - $scope.copyData[i].useQuantity)){
            $scope.showMsg('第'+(i+1)+'项的完成数量不能大于剩余数量');
            return
          }
          var obj = {};
          obj.id = $scope.copyData[i].logId;
          obj.materialsId = $scope.copyData[i].id;
          obj.projectTaskId = $scope.projectTaskId;
          obj.useQuantity = $scope.copyData[i].logNum || 0;
          obj.numBefore = $scope.copyData[i].quantity - $scope.copyData[i].useQuantity;
          obj.numAfter = $scope.copyData[i].quantity - $scope.copyData[i].useQuantity - $scope.copyData[i].logNum;
          arr.push(obj)
        }

        PerformTaskService.doSaveMaterials(JSON.stringify(arr)).success(function (res) {
          $scope.showMsg('保存成功');
          $timeout(function () {
            $scope.goBack()
          },1000);
        }).error(function (res) {
          if (res.errorCode == '000002') {
            var confirmPopup = $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function (res) {
              if (res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        })
      };

    $scope.$on('$ionicView.enter', function () {
        $scope.getList();
    });
  });
  return controller;
});
