/*
 * @Author: HuangTiger
 * @Date:   2017-05-27 14:09:46
 * @Last Modified by:   HuangTiger
 * @Last Modified time: 2017-06-15 15:57:54
 */

define(function (require) {
  'use strict';
  var routes = angular.module("performTask.route", []);

  //taskarrangement...
  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('performTask', {
        url: '/performTask',
        abstract: true,
        templateUrl: 'modules/performTask/templates/tabs-details.html'
      })
      .state('performTask.details', {
        url: '/details/:projectTaskId/:source',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/taskDetails.html',
            controller: "PerformController"
          }
        }
      })
      .state('performTask.guidance', {
        url: '/guidance/:projectTaskId/:type',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/guidance.html',
            controller: "PerformGuidanceController"
          }
        }
      })
      .state('performTask.registration', {
        url: '/registration/:projectTaskId/:projectTaskItemId/:type',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/registration.html',
            controller: "PerformRegistrationController"
          }
        }
      })
      .state('performTask.addPicture', {
        url: '/addPicture/:projectTaskItemEventId/:poText/:modeValue/:status',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/addPicture.html',
            controller: "PerformPictureController"
          }
        }
      })
      .state('performTask.problemDetails', {
        url: '/problemDetails/:projectTaskItemId',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/problemDetails.html',
            controller: "PerformProblemController"
          }
        }
      })
      .state('performTask.taskList', {
        url: '/taskList/:projectId/:projectSubId/:status/:type',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/taskList.html',
            controller: "PerformTaskListController"
          }
        }
      })
      .state('performTask.downloadLists', {
        url: '/downloadLists/:projectTaskItemId/:projectTaskItemEventId',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/downloadLists.html',
            controller: "PerformDownloadListController"
          }
        }
      })
      .state('performTask.willSign', {
        url: '/willSign/:projectTaskItemId',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/willSign.html',
            controller: "PerformWillSignController"
          }
        }
      })
      //工程量入口
      .state('performTask.quantities', {
        url: '/quantities/:projectId/:projectTaskId',
        cache: false,
        views: {
          'tabs-enter-details': {
            templateUrl: 'modules/performTask/templates/quantities.html',
            controller: "PerformQuantitiesController"
          }
        }
      });

  });

  return routes;
});
