define(['performTask.boot'], function(require){
  'use strict';

  var service = angular.module('performTask.services');
  service.factory('PerformTaskService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      getTaskDetail: function(projectTaskId){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getTaskDetail',
          dataType: "json",
          params:{
            projectTaskId:projectTaskId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getDictItem: function(dictionaryEname){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getDictItem',
          dataType: "json",
          params:{
            dictionaryEname:dictionaryEname,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getResponsibilityUnit: function(projectTaskId,projectTaskItemId){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getResponsibilityUnit',
          dataType: "json",
          params:{
            projectTaskId:projectTaskId,
            projectTaskItemId:projectTaskItemId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doCreateTrouble: function(params){
        var deferred = $q.defer(),
          promise = deferred.promise;
        params.usertoken = Storage.get('userInfo').usertoken;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/doCreateTrouble',
          dataType: "json",
          params:params
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getTroubleList: function (start,limit,projectTaskItemId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getTroubleList',
          dataType: "json",
          params: {
            start:start,
            limit:limit,
            projectTaskItemId:projectTaskItemId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getAttachmentList: function (tableId,tableName,type,category) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/getAttachmentList',
          dataType: "json",
          params: {
            tableId:tableId,
            tableName:tableName,
            type:type,
            category:category,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getDownloadList: function (options) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getDownloadList',
          dataType: "json",
          params: options
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      deletePic: function (ids,projectTaskItemEventId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/deletePic',
          dataType: "json",
          params: {
            ids:ids,
            projectTaskItemEventId:projectTaskItemEventId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doChangeTaskItemStatus: function (projectTaskItemId,status) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/doChangeTaskItemStatus',
          dataType: "json",
          params: {
            projectTaskItemId:projectTaskItemId,
            status:status,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doPerformInspection: function (projectTaskItemId,modeValue) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/doPerformInspection',
          dataType: "json",
          params: {
            projectTaskItemId:projectTaskItemId,
            modeValue:modeValue,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doEndProjectTask: function (projectTaskId) {
      var deferred = $q.defer(),promise = deferred.promise;
      $http({
        method: 'POST',
        url: ENV.api + '/todayTask/doEndProject',
        dataType: "json",
        params: {
          projectTaskId:projectTaskId,
          usertoken:Storage.get('userInfo').usertoken
        }
      }).success(function (res) {
        if(res && res.success){
          deferred.resolve(res);
        } else {
          deferred.reject(res);
        }

      });
      promise.success = function (fn) {
        promise.then(fn);
        return promise;
      }
      promise.error = function (fn) {
        promise.then(null, fn);
        return promise;
      }
      return promise;
    },
      getProjectMaterials: function (projectId,mname,projectTaskId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getProjectMaterials',
          dataType: "json",
          params: {
            projectId:projectId,
            mname:mname || '',
            projectTaskId: projectTaskId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doSaveMaterials: function (str) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/doSaveMaterials',
          dataType: "json",
          params: {
            materials:str || '',
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      }


    };
  });
  return service;
});
