define(['personManage.boot'], function (require) {
  'use strict';

  var controller = angular.module('personManage.controllers');

  controller.controller('PersonnelManagementController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, PersonnelService) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.datalist=[];
    $scope.start = 0;
    $scope.limit =15;
    $scope.showNull = false;


    $scope.openUrl=function(url){
      if (!cordova.InAppBrowser) {
          return;
      }
    cordova.InAppBrowser.open(url, '_blank', 'location=no,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭');
    }

    //下拉刷新
    $scope.onPullRefresh = function () {

          $scope.$broadcast('scroll.refreshComplete');
    };
    var usertoken =  Storage.get("userInfo").usertoken;

    $scope.loadMore = function () {
     PersonnelService.staffList($scope.start, $scope.limit,usertoken)
     .success(function (res) {
     if(res){
       var records = res.userList;
       $scope.start = $scope.start + records.length;
       $scope.datalist = $scope.datalist.concat(records);
       $scope.showNull = !$scope.datalist.length > 0;
     if( records.length >= $scope.limit){
       $scope.hasMore = true;
     } else{
       $scope.hasMore = false;
     }
     $scope.$broadcast('scroll.infiniteScrollComplete');
     }
     }).error(function (res) {
       if (res.errorCode == '000002') {
         var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
      });
    };
    $scope.loadMore();

  });


  return controller;
});
