define(['personManage.boot'], function (require) {
  'use strict';

  var controller = angular.module('personManage.controllers');

  controller.controller('PersonnelManagementFetailsController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $cordovaToast,$cordovaFileTransfer,$cordovaDevice,$state, $stateParams,$ionicHistory,$cordovaFileOpener2,$ionicLoading,$interval, $filter,Storage,PersonnelService) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };


    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    //多图片预览变量
    $scope.imgShou = [];
    $scope.soDoImg = [];
    $scope.activeImgIndex = undefined;

    $scope.titleTxt =  $stateParams.name;

     $scope.source = $stateParams.source;
    $scope.showNull = false;
    $scope.bigImage = false;
    $scope.hideBigImage = function () {

      $scope.bigImage = false;
    };

    //点击图片放大
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = '/file/getPic?id='+item.id+'&isCompress=false';
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, ENV.api, function (success) {
        }, function (error) {
        }
      );
    };

    $scope.isCheckPerson = Storage.get("isCheckPerson");
    var taskId= $stateParams.taskId;
    PersonnelService.getTaskItemList(taskId)
    .success(function (res) {
    if(res){
       $ionicLoading.hide();
        $scope.project = res.project;
        $scope.projectTask = res.projectTask;
        $scope.projectTaskItems = res.projectTaskItems;

       console.log($scope.projectTaskItems);

        $scope.templateTask = res.templateTask;
        $scope.showNull = !$scope.projectTaskItems.length > 0;
        $scope.CurrentExecutiveStaff =res.CurrentExecutiveStaff;
        $scope.isSecurityOfficer =res.isSecurityOfficer;
        //有人说你一个人到处旅行走走停停---多图片预览图片展示前戏
        for (var i = 0; i < res.projectTaskItems.length; i++) {
          $scope.imgShou[i] = [];
          for (var j = 0; j < res.projectTaskItems[i].taskItem.fileList.length; j++) {
            if (res.projectTaskItems[i].taskItem.fileList[j].type == "image") {
              //  $scope.imgShou[i][j] = ENV.api + '/file/getPic?id='+ res.projectTaskItems[i].taskItem.fileList[j].id  +'&isCompress=false';
              $scope.imgShou[i].push(ENV.api + '/file/getPic?id='+ res.projectTaskItems[i].taskItem.fileList[j].id  +'&isCompress=false');
            }
          }
        }
    }
    }).error(function (res) {
       $ionicLoading.hide();
       if (res.errorCode == '000002') {
         var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
    });
    $scope.download = function(item){
  		var base = ENV.api+'/file/down/',
  		  dataPath = item.id;
  			$log.log(base + dataPath);
  			var confirmPopup = $ionicPopup.confirm({
  				title: '下载提示',
  				template: '确认下载吗？',
  				buttons: [{
  					 text: '取消',
  					 type: 'button-default',
  					 onTap: function(e) {
  						 // 当点击时，e.preventDefault() 会阻止弹窗关闭。
  					 }
  				 }, {
  					 text: '确认',
  					 type: 'button-positive',
  					 onTap: function(e) {
  						var url = base + dataPath,
  			          targetDir = cordova.file.externalDataDirectory || cordova.file.dataDirectory,
  			          targetPath = targetDir + item.oldName,
  			          trustHosts = true,
  			          options = {},
  			          platform;
  			      if(window.device){
  			        platform = $cordovaDevice.getPlatform();
  			      }
  			      $ionicLoading.show({
  			          template: '正在下载, 请稍候...',
  			          noBackdrop: true
  			      });
  			      $cordovaFileTransfer.download(url, encodeURI(targetPath), options, trustHosts).then(function(result) {
  			        $ionicLoading.hide();
  			        $ionicPopup.confirm({
  			            title: '提示信息',
  			            template: '文件下载成功, 打开文件需安装文档查看应用(如:WPS).<br/>保存位置: <br/>' + targetPath,
  			            cancelText: '关闭',
  			            okText: '立即打开'
  			        }).then(function (res) {
  			          var ldot = targetPath.lastIndexOf(".");
  			          var type = targetPath.substring(ldot + 1);
  			          if(res){
  			            if(platform === 'iOS'){
  			              if(type == 'png'){
  			                  $cordovaFileOpener2.open(encodeURI(targetPath), 'image/png');
  			              }else if(type == 'bmp'){
  			                  $cordovaFileOpener2.open(encodeURI(targetPath), 'image/bmp');
  			              }else if(type == 'jpe' || type == 'jpeg'|| type == 'jpg'){
  			                  $cordovaFileOpener2.open(encodeURI(targetPath), 'image/jpeg');
  			              }else{
  			                  $cordovaFileOpener2.open(encodeURI(targetPath), 'application/pdf');
  			              }
  			            }else{
  			              if(type == 'png'){
  			                  $cordovaFileOpener2.open(targetPath, 'image/png');
  			              }else if(type == 'bmp'){
  			                  $cordovaFileOpener2.open(targetPath, 'image/bmp');
  			              }else if(type == 'jpe' || type == 'jpeg'|| type == 'jpg'){
  			                  $cordovaFileOpener2.open(targetPath, 'image/jpeg');
  			              }else{
  			                  $cordovaFileOpener2.open(targetPath, 'application/pdf').then(function() {
  			                  }, function(err) {
  			                  });
  			              }
  			            }
  		          	}
  		        });
  		      }, function(err) {
  		        $log.error('文件下载失败', err);
  		        $ionicLoading.hide();
  		        $cordovaToast.showShortBottom("文件下载失败");
  		      }, function (progress) {
  		      });
  				}
  			}]
  			});
      };
  });

  controller.controller('TaskQListsController', function (ENV, $scope,  $ionicLoading,  QListsService, $ionicHistory, Storage,  $stateParams) {
        $scope.History = {
          goBack: function () {
            $ionicHistory.goBack();
          }
        };
        var taskId = $stateParams.taskId;
        $scope.datalist = [];
        $scope.showNull = false;
        QListsService.getTaskTroubleList(taskId)
          .success(function (res) {
            if (res && res.record.length !== 0) {
              //有数据
              $scope.showNull = false;
              $scope.datalist =  res.record;
            }else{
              //无数据
              $scope.showNull = true;
            }
          }).error(function (res) {
            //无数据
            $scope.showNull = true;
            if (res.errorCode == '000002') {
              var confirmPopup =  $ionicPopup.alert({
                     title: '提示信息',
                     template: '该帐号已在其他设备登录！',
                     okText: '确定',
                     okType: 'button-assertive'
                   });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            }
          });

  });

  return controller;
});
