define(['personManage.boot'], function (require) {
  'use strict';

  var controller = angular.module('personManage.controllers');

  controller.controller('SubkeyController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory,$interval,$ionicLoading, $stateParams,Storage,PersonnelService) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };

    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    $scope.isCheckPerson = Storage.get("isCheckPerson");
    $scope.showNull = false;
     var confirmPopup = null;
    $scope.datalist=[];
    $scope.start = 0;
    $scope.limit = 15;
    $scope.subProjectId = 0;
    var projectId =  $stateParams.projectId;
    var userId = $stateParams.userId;
    PersonnelService.getProject(projectId,userId)
    .success(function (res) {
    if(res){
        $scope.project = res.projectDto;
        $scope.isSecurityOfficer = res.isSecurityOfficer;
        if($scope.project.projectSubDtoList.length>0){
            $scope.subProjectId=$scope.project.projectSubDtoList[0].id;
        }

        $scope.loadMore();
    }
    }).error(function (res) {
       $ionicLoading.hide();
       if (res.errorCode == '000002') {
         if(confirmPopup==null){
          confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
       }
    });
    $scope.loadMore = function () {
     PersonnelService.getProjectTaskLlist($scope.start, $scope.limit,projectId,$scope.subProjectId,userId)
     .success(function (res) {
     if(res){
       var records = res.taskList;
       $scope.start = $scope.start + records.length;
       $scope.datalist = $scope.datalist.concat(records);
       $scope.showNull = !$scope.datalist.length > 0;



     if( records.length >= $scope.limit){
       $scope.hasMore = true;
     } else{
       $scope.hasMore = false;
     }
     $ionicLoading.hide();
     $scope.$broadcast('scroll.infiniteScrollComplete');
     }
     }).error(function (res) {
       $ionicLoading.hide();
       if (res.errorCode == '000002') {
            if(confirmPopup==null){
          confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
     }
      });
    };

    $scope.onSlideChanged = function (index) {
      $scope.datalist=[];
      $scope.start = 0;
      if ($scope.project.projectSubDtoList.length <= 2) {

         index = index%$scope.project.projectSubDtoList.length;
      }
      $scope.subProjectId=$scope.project.projectSubDtoList[index].id;
      $scope.loadMore();
    };
  });


  return controller;
});
