define(['personManage.boot'], function(require){
  'use strict';

  var service = angular.module('personManage.services');
  service.factory('PersonnelService', function($q, $http, $log,Storage, $base64, ENV) {
    return {
      //获取列表
      staffList: function(start, limit,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/user/userlist',
              dataType: "json",
              params: {
                start : start,
                limit : limit,
                userToken : usertoken
              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      //获取人员有关的项目
      projectListByUser: function(status,start, limit,userId){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/project/userProjectlist',
              dataType: "json",
              params: {
                status : status,
                start : start,
                limit : limit,
                userId : userId,
                usertoken:Storage.get('userInfo').usertoken
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      //获取项目
      getProject: function(projectId,userId){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/project/getProject',
              dataType: "json",
              params: {
                projectId : projectId,
                userId : userId,
                usertoken:Storage.get('userInfo').usertoken
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
    //获取项目任务
    getProjectTaskLlist: function(start,limit,projectId,subProjectId,userId){
          var deferred = $q.defer(),
              promise = deferred.promise;
          $http({
            method: 'POST',
            url: ENV.api + '/project/getProjectTaskLlist',
            dataType: "json",
            params: {
              start : start,
              limit : limit,
              projectId : projectId,
              subProjectId : subProjectId,
              userId : userId,
              usertoken:Storage.get('userInfo').usertoken
            }
          }).success(function(res){
            if(res && res.success){
              deferred.resolve(res.record);
            } else {
              deferred.reject(res);
            }
          });

          promise.success = function(fn) {
              promise.then(fn);
              return promise;
          }
          promise.error = function(fn) {
              promise.then(null, fn);
              return promise;
          }
          return promise;
        },
        //获取任务检查项
        getTaskItemList: function(taskId){
              var deferred = $q.defer(),
                  promise = deferred.promise;
              $http({
                method: 'POST',
                url: ENV.api + '/project/getTaskItemList',
                dataType: "json",
                params: {
                  taskId : taskId,
                  usertoken:Storage.get('userInfo').usertoken

                }
              }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
              });

              promise.success = function(fn) {
                  promise.then(fn);
                  return promise;
              }
              promise.error = function(fn) {
                  promise.then(null, fn);
                  return promise;
              }
              return promise;
            }
    };
  });
  return service;
});
