define(['portal.boot'], function(require){
  'use strict';
  var controller = angular.module('portal.controllers');
  controller.controller('LoginController', function(ENV, $http, $base64, $scope, $log, $timeout, $ionicHistory, $rootScope, $ionicPopup, $state,$ionicLoading, $cordovaToast, Storage, AuthService) {

    $ionicHistory.nextViewOptions({
      disableBack: true
    });
    $scope.$on('$stateChangeSuccess', function() {
      $scope.user = {
        username: '',
        password: ''
      };

      $ionicHistory.clearCache();
      $ionicHistory.clearHistory();
      $scope.keyboard = {show: false};
    });
    $scope.$on('$ionicView.enter', function () {

      var user = Storage.get('useridNumStr');

      if (user != undefined) {

        var alias = user;

        window.JPush.deleteAlias({ sequence: 2, alias: alias },function (success) {
          console.log(success);
          Storage.remove('useridNumStr');
        },function (error) {
          console.log(error);
        });
      }

    });
    //删除token
    // if(Storage.get('refreshToken')){
    //   AuthService.revokeToken(Storage.get('refreshToken'));
    // }
    //登陆认证，获取token
    $scope.doLogin = function(user){
      if(!user.username|| !user.password || typeof(user) == 'undefined'){
  			//$scope.showAlert('请输入用户名和密码.');
        $ionicLoading.show({
         template: "请输入帐号和密码。",
         duration: 800
        });
  			return false;
  		}

      var checkPss = /^(?=.*[0-9])(?=.*[a-zA-Z])(?=.*[`_\-+~!@#$^&*()=|{}':;',\[\].<>~！@#￥……&*（）——|{}【】‘；：”“'。，、？]).{8,20}$/;
      if(!checkPss.test(user.password)){
        //$scope.showAlert('密码只能由字母数字下划线组成.');
        $ionicLoading.show({
         template: "密码必须由字母、数字和符号三样组成。",
         duration: 800
        });
        return false;
      }

      $ionicLoading.show({
        template: '登录中，请稍候...',
        noBackdrop: true,
        duration: 10000
      });
      Storage.remove('isLogged');
      Storage.remove('userInfo');
      Storage.remove('menuList');
      $scope.userInfo = [];
      AuthService.login(user.username, user.password).success(function(data) {
        var idNumStr = '' + data.id;
        $scope.userInfo = {name : data.cname, usertoken : data.token};
        Storage.set('useridNumStr', idNumStr);
        Storage.set('userInfo', $scope.userInfo);
        Storage.set('isLogged', true);
        var usertoken = Storage.get("userInfo").usertoken;
        //查看时候有安置检查的权
        AuthService.isCheck(usertoken)
          .success(function (res) {
             Storage.set("isCheckPerson",res.record);

          }).error(function (data) {
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login')
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });


        AuthService.menuList(usertoken)
          .success(function (res) {
             Storage.set("menuList",res.record.menuList);
            if (res) {
              $rootScope.$broadcast('$authSuccess');
              checkUpdatePassword();
            }

          }).error(function (data) {
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login')
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });
        $ionicLoading.hide();

      }).error(function(data) {
          $ionicLoading.hide();
          Storage.set('isLogged', false);
          if(data == null){
            $ionicLoading.show({
             template: "服务器异常，请稍后再试。",
             duration: 800
            });
          } else {
            $ionicLoading.show({
             template: "登录失败，" + data.msg,
             duration: 800
            });
          }
      });
      //$ionicLoading.hide();
      // checkUpdatePassword();

      //   AuthService.getAccessToken(user.username, user.password).success(function(data) {//api网关获取access_token
      //   console.log(data);
      //   Storage.set('accessToken', data.access_token);
      //   Storage.set('refreshToken', data.refresh_token);
      //   Storage.set('currentUser', data.userInfo);
      //   Storage.set('isLogged', true);
      //   $rootScope.$broadcast('$authSuccess');
      //   $ionicLoading.hide();
      //   checkUpdatePassword();
      // }).error(function(data) {
      //   $ionicLoading.hide();
      //   Storage.set('isLogged', false);
      //   if(data == null){
      //     $ionicLoading.show({
      //      template: "服务器异常，请稍后再试。",
      //      duration: 800
      //     });
      //   } else {
      //     var errorMsg = data.error_description;
      //     if(data.error_description=='Bad credentials'){
      //       errorMsg = '用户名或者密码错误。';
      //     }
      //     if(data.error_description.indexOf('cannot assign') > -1){
      //       errorMsg = '服务器异常。请稍后再试。';
      //     }
      //     $ionicLoading.show({
      //      template: errorMsg,
      //      duration: 800
      //     });
      //   }
      //
      // });
    };

    ////检查是否修改过密码,根据changePasswordCount是否为0判断修改密码.
    var checkUpdatePassword = function(){
      // var currentUser = Storage.get('currentUser');
      // if(currentUser.changePasswordCount == 0){
      //   $state.go('mandatory_checkSetPassword');
      //   $cordovaToast.showShortBottom('为了您的账号安全，请及时修改默认密码.');
      // } else {
      //   $state.go('tabs.home.message');
      // }

      $state.go('tabs.home.message');
    };

    //检查是否修改过密码
    // function checkUpdatePassword(){
    //   $http({
    //     method: 'POST',
    //     url: ENV.api + '/login/checkUpdatePassword',
    //     dataType: "json",
    //     params: {
    //       telephone: $base64.encode(Storage.get('currentUser').telephone)
    //     }
    //   }).success(function(res){
    //     if(!res || !res.record){
    //       return;
    //     }
    //     if(res.record.updateFlag == 0){
    //       $state.go('mandatory_checkSetPassword');
    //       $cordovaToast.showShortBottom('为了您的账号安全，请及时修改默认密码.');
    //     }
    //     else{
    //       $state.go('tabs.home.message');
    //     }
    //   });
    // };

    // $rootScope.$on('$HttpResponseError', function(o){
    //   console.log(o);
    //   $ionicLoading.hide();
    //   //$scope.showAlert("请求接口异常.");
    //   $cordovaToast.showShortBottom("对不起！系统忙，请稍后再试！");
    // });

    // $scope.showAlert = function(message, title) {
    //   var alertPopup = $ionicPopup.alert({
    //     title: title || '提示信息',
    //     template: message,
    //     okText: '确定',
    //     okType: 'bar-iccs light font-yahei'
    //   });
    // };

  });
  return controller;
});
