define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('MailListDetailsController', function (ENV, $cordovaSms,$scope, $log, $window,$timeout, $rootScope, $ionicPopup, $ionicActionSheet,$stateParams,$state, $ionicHistory , $ionicLoading, $interval, Storage, MailListService) {

    $scope.goBack = function() {
        $ionicHistory.goBack();
    };

    MailListService.mailDetail($stateParams.id)
    .success(function (data) {
      console.log(data);
      $scope.titleTxt = data.cname;
      $scope.phoneTex = data.userName;
      $scope.orgs = data.orgs;
      $scope.roles = data.roles;
    }).error(function (data) {
      if(data == null){
        $ionicLoading.show({
         template: "服务器异常，请稍后再试。",
         duration: 800
        });
      } else {
        $ionicLoading.show({
         template: data.msg,
         duration: 800
        });
      }
     });


    $scope.chooseState = function () {

      $ionicActionSheet.show({
        buttons: [
          {text: '呼叫联系人'},
          {text: '发送短信'}
        ],
        titleText: '',
        cancelText: '返回',
        cancel: function () {

        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              // $window.location.href = "tel:" + $scope.phoneTex;  // 呼叫联系人
              $window.open('tel:' + $scope.phoneTex,'_system');
              break;
            case 1:
              console.log("发送消息:" + $scope.phoneTex);  // 发送短信
              var options = {
                replaceLineBreaks: false,
                android: {
                intent: 'INTENT'
                }
              };
              $cordovaSms.send($scope.phoneTex, '', options)
              break;
            default:
              break;
          }
          return true;
        }
      });

    };
  });

  return controller;
});
