define(['portal.boot'], function(require){
  'use strict';
  var controller = angular.module('portal.controllers');
  controller.controller('SetNewPasswordController', function(ENV, $http, $base64, $scope, $log, $timeout, $ionicHistory, $rootScope, $ionicPopup, $state, $ionicLoading, $cordovaToast, Storage, AuthService) {

  $scope.clickSure = function(user) {
    var pwdReg = /^(?=.*[0-9])(?=.*[a-zA-Z])(?=.*[`_\-+~!@#$^&*()=|{}':;',\[\].<>~！@#￥……&*（）——|{}【】‘；：”“'。，、？]).{8,20}$/;
    if (typeof(user) == 'undefined' || !user.password) {
      $ionicLoading.show({
       template: "请输入旧密码",
       duration: 800
      });
      return false;
    } else if (!user.password2) {
      $ionicLoading.show({
       template: "请输入新密码",
       duration: 800
      });
      return false;
    } else if (!user.password3) {
      $ionicLoading.show({
       template: "请输入确认新密码",
       duration: 800
      });
      return false;
    } else if (!pwdReg.test(user.password2)) {
      $ionicLoading.show({
       template: "密码必须由字母、数字和符号三样组成且长度在8-20之间",
       duration: 800
      });
      return false;
    }  else if (user.password2 !== user.password3) {
      $ionicLoading.show({
       template: "新密码与确认新密码不一致！",
       duration: 800
      });
      return false;
    } else {
      $scope.usertoken = Storage.get('userInfo').usertoken;
      $scope.projects = [];
      AuthService.changePassword(user.password, user.password2, user.password3, $scope.usertoken)
      .success(function (data) {
          $ionicPopup.confirm({
            title: '提示信息',
            template: '修改成功，请重新登录！',
            buttons: [{
               text: '确认',
               type: 'button-positive',
               onTap: function(e) {
                 Storage.remove('isLogged');
                 Storage.remove('userInfo');
                 Storage.remove('menuList');
                 $state.go('login');
               }
             }]
          });
      }).error(function (data) {
          if(data == null){
            $ionicLoading.show({
             template: "服务器异常，请稍后再试。",
             duration: 800
            });
          } else if (data.errorCode == '000002') {


              var confirmPopup =  $ionicPopup.alert({
                     title: '提示信息',
                     template: '该帐号已在其他设备登录！',
                     okText: '确定',
                     okType: 'button-assertive'
                   });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });



          } else {
            $ionicLoading.show({
             template: data.msg,
             duration: 800
            });
          }
       });
    }
  };

  });
  return controller;
});
