define(['portal.boot'], function(require){
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('WelcomeController', function(ENV, $scope, $log, $timeout, $rootScope, $state, $ionicHistory,$ionicSlideBoxDelegate, Storage) {
    $log.log('Welcome Controller');
    $scope.guideSure = function(index) {
      var pageNum=$ionicSlideBoxDelegate.slidesCount();
      if(index==pageNum-1){
        $ionicHistory.nextViewOptions({
          disableBack: true
        });
        $state.go('tabs.home.message');
        Storage.set('skipWelcome', true);
      }
      //$ionicHistory.clearCache();
    };
  });

  controller.controller('TokenLoadingController', function(ENV, $scope, $log, $timeout, AuthService, $rootScope, $state, $ionicPopup, $ionicHistory,$ionicSlideBoxDelegate, Storage) {
    var usertoken = null;
    if (Storage.get("userInfo")) {
        usertoken = Storage.get("userInfo").usertoken;
    }
    var isLogged= Storage.get("isLogged");
    if(isLogged){
      AuthService.menuList(usertoken)
        .success(function (res) {
          if (res && res.record) {
           Storage.set("menuList",res.record.menuList);
          }
        }).error(function (data) {
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else  if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        });
    }



    $timeout(function () {
        $state.go('tabs.home.message');
      },500);
    // $log.log('TokenLoadingController 刷新token...');
    //
    // //accessToken,refreshToken 为空重新登录
    // if(!Storage.get('accessToken') || !Storage.get('refreshToken')){
    //   Storage.set('isLogged', false);
    //   $state.go('login');
    // };
    //
    // //获取上次获取token的时间
    // var date1 = Storage.get('getTokenTime');
    // var needRE = false;
    // if(date1){
    //   var date2=new Date();
    //   var date1 = new Date(date1.replace(/-/g, '/'));
    //   var date3=date2.getTime()-date1.getTime();
    //   var leave1=date3%(24*3600*1000);
    //   var hours=Math.floor(leave1/(3600*1000));
    //   //超过2天需要刷新
    //   if(hours>=48){
    //     needRE = true;
    //   }
    // }else{
    //   needRE = true;
    // }
    //
    // //刷新token
    // if(needRE){
    //   Date.prototype.pattern=function(fmt) {
    //       var o = {
    //       "M+" : this.getMonth()+1, //月份
    //       "d+" : this.getDate(), //日
    //       "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时
    //       "H+" : this.getHours(), //小时
    //       "m+" : this.getMinutes(), //分
    //       "s+" : this.getSeconds(), //秒
    //       "q+" : Math.floor((this.getMonth()+3)/3), //季度
    //       "S" : this.getMilliseconds() //毫秒
    //       };
    //       var week = {
    //       "0" : "/u65e5",
    //       "1" : "/u4e00",
    //       "2" : "/u4e8c",
    //       "3" : "/u4e09",
    //       "4" : "/u56db",
    //       "5" : "/u4e94",
    //       "6" : "/u516d"
    //       };
    //       if(/(y+)/.test(fmt)){
    //           fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    //       }
    //       if(/(E+)/.test(fmt)){
    //           fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);
    //       }
    //       for(var k in o){
    //           if(new RegExp("("+ k +")").test(fmt)){
    //               fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
    //           }
    //       }
    //       return fmt;
    //   }
    //
    //   var currentUser = Storage.get('currentUser');
    //   var refreshToken = Storage.get('refreshToken');
    //   $log.log('开始刷新token...');
    //   AuthService.getAccessTokenByRefreshToken(refreshToken).success(function(data){
    //     $log.log('首页刷新token结束，开始刷新OA，token...');
    //     Storage.set('accessToken', data.access_token);
    //     Storage.set('currentUser', angular.extend({}, currentUser, data.userInfo));
    //     Storage.set('getTokenTime',new Date().pattern("yyyy-MM-dd HH:mm:ss"));
    //     $timeout(function () {
    //       $state.go('tabs.home.message');
    //     },1000);
    //   }).error(function(data) {
    //     $timeout(function () {
    //       //refreshToken过期，重新登录
    //       Storage.set('isLogged', false);
    //       $state.go('login');
    //     },1000);
    //   });
    // }else{
    //   $timeout(function () {
    //     $state.go('tabs.home.message');
    //   },1000);
    // }
  });

  return controller;
});
