define(function (require) {
  'use strict';
  var routes = angular.module("portal.route", []);
  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('login', {
        url: '/login',
        templateUrl: 'modules/portal/templates/login.html',
        controller: 'LoginController',
        loginRequried: false
      })
      .state('tabs', {
        url: '/tabs',
        abstract: true,
        templateUrl: 'modules/portal/templates/tabs.html'
      })

      .state('tabs.home', {
        url: '/home',
        abstract: true,
        views: {
          'tabs-home': {
            templateUrl: 'modules/portal/templates/tabs-home.html',
            controller: "TabsHomeController"
          }
        }
      })

      .state('tabs.mine', {
        url: '/mine',
        views: {
          'tabs-mine': {
            templateUrl: 'modules/portal/templates/mine/index.html',
            controller: "TabsMineController"
          }
        }
      })
      .state('welcome', {
        url: '/welcome',
        templateUrl: 'modules/portal/templates/welcome/welcome.html',
        controller: 'WelcomeController',
        loginRequried: false
      })
      .state('tokenLoading', {
        url: '/tokenLoading',
        templateUrl: 'modules/portal/templates/tokenLoading.html',
        controller: 'TokenLoadingController',
        loginRequried: false
      })
      .state('checkSetPassword', {
        url: '/checkSetPassword',
        cache: false,
        templateUrl: 'modules/portal/templates/checkSetPassword.html',
        controller: 'TabsMineUpdatePasswordController'
      })
      .state('mandatory_checkSetPassword', {
        url: '/mandatory_checkSetPassword',
        templateUrl: 'modules/portal/templates/mandatory_checkSetPassword.html',
        controller: 'TabsMineUpdatePasswordController'
      })
      .state('forget_checkSetPassword', {
        url: '/forget_checkSetPassword',
        cache: false,
        templateUrl: 'modules/portal/templates/forget_checkSetPassword.html',
        controller: 'TabsMineUpdatePasswordController',
        loginRequried: false
      })
      .state('newPassword', {
        url: '/newPassword',
        cache: false,
        templateUrl: 'modules/portal/templates/newPassword.html',
        controller: 'SetNewPasswordController',
        loginRequried: false
      })

      .state('securityCheck', {
        url: '/securityCheck/:checkId/:source',
        cache: true,
        templateUrl: 'modules/portal/templates/securityCheck.html',
        controller: 'SecurityCheckController',
      })

    // if (window.localStorage.getItem('skipWelcome')) {
    //   $urlRouterProvider.otherwise('/tokenLoading');
    // } else {
    //   $urlRouterProvider.otherwise('/welcome');
    // }
    .state('choosePersonLiable', {
      url: '/choosePersonLiable/:checkId/:source/:projectId',
      cache: false,
      templateUrl: 'modules/portal/templates/choosePersonLiable.html',
      controller: 'ChoosePersonLiableController',
    })

    if (window.localStorage.getItem('isLogged')) {
     $urlRouterProvider.otherwise('/tokenLoading');
   } else {
     $urlRouterProvider.otherwise('/login');
   }

  });

  // tabs.home. ...
  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('tabs.home.message', {
        url: '/message',
        views: {
          'tabs-home-message': {
            templateUrl: 'modules/portal/templates/home/message.html',
            controller: "TabsHomeMessageController"
          }
        }
      })
      .state('mailListGParent', {
        url: '/mailListGParent/:isChooserPerson',
        templateUrl: 'modules/portal/templates/addressList/mailListGParent.html',
        controller: 'MailListGParentController'
      })
      .state('mailListParent', {
        url: '/mailListParent',
        templateUrl: 'modules/portal/templates/addressList/mailListParent.html',
        controller: 'MailListParentController'
      })
      .state('mailList', {
        url: '/mailList/:org/:title/:adressName/:isChooserPerson',
        templateUrl: 'modules/portal/templates/addressList/mailList.html',
        controller: 'MailListController'
      })

      .state('mailListDetails', {
        url: '/mailListDetails/:id',
        cache: false,
        templateUrl: 'modules/portal/templates/addressList/mailListDetails.html',
        controller: 'MailListDetailsController'
      })
      ;
  });

  return routes;
});
