define(['personManage.boot'], function(require){
  'use strict';

  var service = angular.module('portal.services');
  service.factory('MailListService', function($q, $http, $log, $base64, ENV) {
    return {
      //获取通讯录列表
      mailList: function(adressName,org){
            console.log(ENV.api + '/user/mailList');
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/user/mailList',
              dataType: "json",
              params: {
                adressName : adressName,
                org:org
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      mailOrgList: function(start,limit,ename){

            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/user/mailOrgList',
              dataType: "json",
              params: {
                start : start,
                limit : limit,
                ename : ename

              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      mailDetail: function(id){

            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/user/mailDetail',
              dataType: "json",
              params: {
                id:id

              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          }
    };
  });
  return service;
});
