define(['portal.boot'], function(require){
  'use strict';

  var service = angular.module('portal.services');
  service.factory('SecurityService', function($q, $http, $log, $base64,Storage, ENV) {
    return {
      getCheck: function(checkId,source){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/securityCheck/getCheck',
          dataType: "json",
          params: {
            checkId:checkId,
            source:source,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
      violationTypeList: function(){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/trouble/violationTypeList',
          dataType: "json",
          params: {

          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
      violationItmeList: function(type){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/trouble/violationItmeList',
          dataType: "json",
          params: {
            type:type

          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
      troubleType: function(){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/trouble/troubleType',
          dataType: "json",
          params: {

          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
      getResponsibility: function(checkId,source,projectId){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/securityCheck/getResponsibility',
          dataType: "json",
          params: {
            checkId : checkId,
            source :source,
            projectId : projectId
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
      doCheck: function(check){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url:ENV.api +  '/securityCheck/doCheck',
          dataType: "json",
          params: {
            check:check,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      },
    };
  });
  return service;
});
