/**
 * @Author:      LufeiBoy
 * @DateTime:    null
 * @Description: 项目动态的controller
 * @Last Modified By:   LufeiBoy
 * @Last Modified Time:    null
 */
define(['projectDynamics.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectDynamics.controllers');

  controller.controller('ProjectDynamicsacController', function (ENV,$window,$filter, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, ProjectDynamicsacService) {

    $scope.itemsTime = [];
    var confirmPopup = null;
      $scope.items = [

            ];
            $scope.History = {
              goBack: function () {
                $ionicHistory.goBack();
              }
            };
            $scope.datalist=[];
            $scope.start = 0;
            $scope.limit = 15;
            $scope.showNull = false;
            $scope.date=$filter('date')(new Date(),'yyyy-MM-dd');
            //下拉刷新
            $scope.onPullRefresh = function () {

              $scope.datalist=[];
              $scope.start = 0;
              $scope.limit =15;
              $scope.loadMore();

            };
            var usertoken =  Storage.get("userInfo").usertoken;
            $scope.loadMore = function () {
             ProjectDynamicsacService.list($scope.start, $scope.limit,$scope.date,usertoken)
             .success(function (res) {
             if(res){
               var records = res.list;

               $scope.start = $scope.start + records.length;;
               $scope.datalist = $scope.datalist.concat(records);
               $scope.showNull = !$scope.datalist.length > 0;
               if( records.length >= $scope.limit){
                 $scope.hasMore = true;
               } else{
                 $scope.hasMore = false;
               }
               $scope.$broadcast('scroll.infiniteScrollComplete');
               }
               }).error(function (res) {
                 if (res.errorCode == '000002') {
                   if(confirmPopup==null){
                    confirmPopup =  $ionicPopup.alert({
                          title: '提示信息',
                          template: '该帐号已在其他设备登录！',
                          okText: '确定',
                          okType: 'button-assertive'
                        });
                   confirmPopup.then(function(res) {
                     if(res) {
                       Storage.remove('isLogged');
                       Storage.remove('userInfo');
                       Storage.remove('menuList');
                       $state.go('login');
                     }
                   });
                 }
               }
                });
            };
            $scope.loadMore();

    $scope.timedateDynameic = $scope.date;

       $scope.showPrView = false;

     // 删除proDDKey数据
     if (!$window.localstorage) {
       var storage=$window.localStorage;
       storage.removeItem("proDDKey");
     }
     var calendara = new datePicker2();
     $scope.doSubmit = 0;//判断是否第一次进来
     $scope.selectToggle = function() {

       if(!$scope.showPrView){
         $scope.showPrView = !$scope.showPrView;
       }
        if ($scope.showPrView) {
              calendara.init({
                'trigger': '#projectId2',
                'type': 'date',
                'minDate':'1900-1-1',
                'maxDate':'2100-12-31',
                'onSubmit':function(){
                  // $scope.titleTxt = $filter('date')(calendara.value,'yyyy-MM-dd');
                  $scope.timedateDynameic = $filter('date')(calendara.value,'yyyy-MM-dd');
                  $scope.doSubmit = 1;

                  ProjectDynamicsacService.getNumByDate(calendara.value)
                  .success(function (res) {
                  if(res){
                    console.log( res);
                    $scope.itemsTime = [
                              {  time: calendara.value,menNum:res.num+"人出工"}
                          ];
                  }
                  }).error(function (res) {
                    if (res.errorCode == '000002') {
                      if(confirmPopup==null){
                       confirmPopup =  $ionicPopup.alert({
                             title: '提示信息',
                             template: '该帐号已在其他设备登录！',
                             okText: '确定',
                             okType: 'button-assertive'
                           });
                      confirmPopup.then(function(res) {
                        if(res) {
                          Storage.remove('isLogged');
                          Storage.remove('userInfo');
                          Storage.remove('menuList');
                          $state.go('login');
                        }
                      });
                    }
                    }
                   });
                },
                'onClose':function(){
                  if($scope.doSubmit ==0){
                    $scope.showPrView=false;
                    $scope.onPullRefresh();
                  }
                }

              });

        }
     };

     $scope.clickTimeItem = function(timeNum) {

       var timee = timeNum.substr(5, 5);
       $scope.showPrView = false;
       $scope.titleTxt = timee;
       $scope.date=timeNum;
       $scope.datalist=[];
       $scope.start = 0;
       $scope.limit =15;

       $scope.loadMore();
     };
  });

  return controller;
});
