define(['projectDynamics.boot'], function(require){
  'use strict';

  var service = angular.module('projectDynamics.services');
  service.factory('ProjectDynamicsacService', function($q, $http, $log,Storage, $base64, ENV) {
    return {
        //获取列表
        list: function(start, limit,date,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/projectdynamicsac/getProjectDynamicsac',
              dataType: "json",
              params: {
                start : start,
                limit : limit,
                date:date,
                userToken : usertoken
              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          //获取任务检查项
      getTaskItemList: function(taskId){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/project/getTaskItemList',
              dataType: "json",
              params: {
                taskId : taskId,
                usertoken:Storage.get('userInfo').usertoken

              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          getNumByDate: function(date){
                var deferred = $q.defer(),
                    promise = deferred.promise;
                $http({
                  method: 'POST',
                  url: ENV.api + '/project/getNumByDate',
                  dataType: "json",
                  params: {
                    date : date,
                    usertoken:Storage.get('userInfo').usertoken

                  }
                }).success(function(res){
                  if(res && res.success){
                    deferred.resolve(res.record);
                  } else {
                    deferred.reject(res);
                  }
                });

                promise.success = function(fn) {
                    promise.then(fn);
                    return promise;
                }
                promise.error = function(fn) {
                    promise.then(null, fn);
                    return promise;
                }
                return promise;
              }

    };
  });
  return service;
});
