/*
* @Author: HuangTiger
* @Date:   2017-09-14 09:11:27
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-09-14 09:49:26
*/
define(['projectList.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectList.controllers');

  controller.controller('ProjectListDetailsController', function (ENV,$window, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate,$stateParams, Storage, ProjectService, TaskService) {
    $scope.orgId = $stateParams.id;
    $scope.title = $stateParams.title;
    $scope.History = {
      goBack: function () {
        if($scope.orgId){
          $ionicHistory.goBack();
        }else {
          $state.go('tabs.home.message');
        }
      }
    };
    $scope.goesToStatement = function(id){

    	$state.go('plstatement',{id:id});
    }
    $scope.datalist=[];
    $scope.start = 0;
    $scope.limit =15;
    $scope.level = 0;
    $scope.type = 0;
    $scope.hasMore = false;
    $scope.showPrView = false;// 是否显示全部专业或者全部等级筛选框
    var switchState = 0;// 用来记录筛选框显示状态，从而实现切换时筛选框是否需要显示或隐藏
    $scope.showNull = false;

    $scope.itemsAll = [
              { id: " ", name: '全部专业'}
          ];
    ProjectService.specialtyTypeList()
    .success(function (res) {
        $scope.itemsAll = res;
    });
    $scope.showSpecialtyName = $scope.itemsAll[0].name;
    $scope.itemsGrade = [
              { id: 0, name: '全部等级'}
          ];

    ProjectService.projectGradeList()
    .success(function (res) {
        $scope.itemsGrade = res;
    });
    $scope.showGradeName = $scope.itemsGrade[0].name;



    var usertoken =  Storage.get("userInfo").usertoken;


    $scope.loadMore = function () {

	     ProjectService.getProjectList($scope.start, $scope.limit,$scope.specialty,$scope.level,$scope.orgId,usertoken)
	     .success(function (res) {
		     if(res){
		       var records = res.list;
		       $scope.start = $scope.start + records.length;;
		       $scope.datalist = $scope.datalist.concat(records);
		       $scope.showNull = !$scope.datalist.length > 0;
		     if( records.length >= $scope.limit){
		       $scope.hasMore = true;
		     } else{
		       $scope.hasMore = false;
		     }
         console.log($scope.datalist);
		     $scope.$broadcast('scroll.infiniteScrollComplete');
		     }
	     }).error(function (res) {
	       if (res.errorCode == '000002') {
	         if(confirmPopup == null){
	          confirmPopup =  $ionicPopup.alert({
	                title: '提示信息',
	                template: '该帐号已在其他设备登录！',
	                okText: '确定',
	                okType: 'button-assertive'
	              });
	         confirmPopup.then(function(res) {
	           if(res) {
	             Storage.remove('isLogged');
	             Storage.remove('userInfo');
	             Storage.remove('menuList');
	             $state.go('login');
	           }
	         });
	       }
	       }
	      });
	  }

	  $scope.loadMore();


    $scope.clickAll = function() {


      $scope.showAll = true;
      $scope.showGrade = false;
      if ($scope.showPrView) {
        if (switchState==1) {
          $scope.showPrView = true;
          switchState=0;
        }
        else {
          $scope.showPrView = false;
        }
      }
      else {
         switchState=0;
         $scope.showPrView=true;
      }

    };
    $scope.clickGrade = function() {


      $scope.showAll = false;
      $scope.showGrade = true;
      if ($scope.showPrView) {
        if (switchState==0) {
          $scope.showPrView = true;
          switchState=1;
        }
        else {
          $scope.showPrView = false;
        }
      }
      else {
        switchState=1;
        $scope.showPrView=true;
      }

    };

    // 全部专业
    $scope.clickScreenOne = function(id,name) {
      $scope.showPrView = false;
      $scope.showSpecialtyName= name;
      $scope.datalist=[];
      $scope.start = 0;
      $scope.limit =15;
      $scope.specialty= id;
      $scope.loadMore();

    };
    // 全部等级
    $scope.clickScreenTwo = function(id,name) {
      $scope.showGradeName= name;
      $scope.showPrView = false;
      $scope.datalist=[];
      $scope.start = 0;
      $scope.limit =15;
      $scope.level = id;
      $scope.loadMore();

    };

    $scope.clickBackground = function() {

       $scope.showPrView = false;
    };



  });

  return controller;
});
