/**
 * @Author:      LufeiBoy
 * @DateTime:    null
 * @Description: 项目列表子项列表的controller
 * @Last Modified By:   LufeiBoy
 * @Last Modified Time:    null
 */
define(['projectList.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectList.controllers');

  controller.controller('ProjectListSubitemController', function (ENV,$window,$scope, $log, $timeout, $rootScope, $stateParams,$ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, ProjectService ) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };

    $scope.isCheckPerson = Storage.get("isCheckPerson");
    $scope.titleTxt = $stateParams.tite;

    $scope.projectId = $stateParams.projectId;
    $scope.rbtn = false;
    $scope.redRepDotOne = true;
    $scope.showNull = false;

    // proLBKey数据存储
    if (!$window.localstorage) {
      var storage=$window.localStorage;
      var proLBKey=storage.proLBKey
      if (proLBKey) {
        $scope.titleTxt=proLBKey;
      }
      else {
        storage["proLBKey"]=$scope.titleTxt;
      }
    }
    $scope.datalist=[];
    $scope.status=0;
    $scope.start=0;
    $scope.limit=15;
    var usertoken =  Storage.get("userInfo").usertoken;
    $scope.getSubprojectList = function () {
      ProjectService.subprojectList($scope.start, $scope.limit,$scope.projectId,$scope.status,usertoken)
      .success(function (res) {
      if(res){
        $scope.area = res.area;
        $scope.isSecurityOfficer =res.isSecurityOfficer;
        var  records = res.list;
        $scope.start = $scope.start + records.length;
        $scope.datalist = $scope.datalist.concat(records);
        $scope.showNull = !$scope.datalist.length > 0;
        if( records.length >= $scope.limit){
          $scope.hasMore = true;
        } else{
          $scope.hasMore = false;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');

      }
      }).error(function (res) {
        $scope.showNull = !$scope.datalist.length > 0;
        if (res.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
                 title: '提示信息',
                 template: '该帐号已在其他设备登录！',
                 okText: '确定',
                 okType: 'button-assertive'
               });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
       });
   };
   $scope.getSubprojectList();

    $scope.offMenu = function () {
      $scope.rbtn = false;
    };
    $scope.openScreen = function () {
      $scope.rbtn = !$scope.rbtn;
    };
    $scope.lookMenuOne = function () {
      $scope.rbtn = false;
      $scope.redRepDotOne = true;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = false;
      $scope.datalist=[];
      $scope.status=0;
      $scope.start=0;
      $scope.getSubprojectList();
    };
    $scope.lookMenuTwo = function () {
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = true;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = false;
      $scope.datalist=[];
      $scope.status=4;
      $scope.start=0;
      $scope.getSubprojectList();
    };
    $scope.lookMenuThree = function () {
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = true;
      $scope.redRepDotFour = false;
      $scope.datalist=[];
      $scope.status=3;
      $scope.start=0;
      $scope.getSubprojectList();
    };
    $scope.lookMenuFour = function () {
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = true;
      $scope.datalist=[];
      $scope.status=2;
      $scope.start=0;
      $scope.getSubprojectList();
    };
  });

  return controller;
});
