/**
 * @Author:      LufeiBoy
 * @DateTime:    null
 * @Description: 项目列表子项列表进程的controller
 * @Last Modified By:   LufeiBoy
 * @Last Modified Time:    null
 */
 define(['projectList.boot'], function (require) {
   'use strict';

   var controller = angular.module('projectList.controllers');

   controller.controller('ProjectListSubkeyController', function (ENV, $scope, $ionicSlideBoxDelegate,$log, $timeout, $rootScope, $stateParams,$ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, ProjectService,PersonnelService) {

     $scope.items = [
               { id: 0, name: '问题类型'},
               { id: 1, name: '严重程度'},
               { id: 2, name: '责任人'},
               { id: 3, name: '整改时限'},
               { id: 3, name: '是否违规'}
           ];


     $scope.History = {
       goBack: function () {
         $ionicHistory.goBack();
       }
     };
     var confirmPopup = null;
      $scope.isCheckPerson = Storage.get("isCheckPerson");
     // 缺省图是否显示
     $scope.showNull = false;
     $scope.itemsLunboasd = [];

     $scope.items = [];

     $scope.onSlideChanged = function (index) {
       $scope.datalist=[];
       $scope.start = 0;
       if ($scope.itemsLunboasd.length <= 2) {

          index = index%$scope.itemsLunboasd.length;
       }
       $scope.userId=$scope.itemsLunboasd[index].id;
       $scope.getProjectTaskLlist();
     };
     $scope.datalist=[];
     $scope.start = 0;
     $scope.limit = 15;

     var projectId =  $stateParams.projectId;
     $scope.subProjectId = $stateParams.subprojectId;

     var usertoken =  Storage.get("userInfo").usertoken;
     ProjectService.subprojectPersonList($scope.subProjectId,usertoken)
     .success(function (res) {
     if(res){
       $scope.isSecurityOfficer = res.isSecurityOfficer;

       var records = res.personList;
       $scope.showNull = !records.length > 0;
       $scope.itemsLunboasd = records;
       $ionicSlideBoxDelegate.loop(true); //解决轮播至最后一个不轮播的问题
       $ionicSlideBoxDelegate.update();
       $scope.userId=$scope.itemsLunboasd[0].id;
       $scope.getProjectTaskLlist();
     }
     }).error(function (res) {

        if (res.errorCode == '000002') {
          if(confirmPopup == null){
           confirmPopup =  $ionicPopup.alert({
                 title: '提示信息',
                 template: '该帐号已在其他设备登录！',
                 okText: '确定',
                 okType: 'button-assertive'
               });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
        }
      });


      $scope.getProjectTaskLlist = function (){
        PersonnelService.getProjectTaskLlist($scope.start, $scope.limit,projectId,$scope.subProjectId,$scope.userId)
        .success(function (res) {
        if(res){
          var records = res.taskList;
          $scope.showNull = !records.length > 0;
          $scope.datalist = records;
        }
        }).error(function (res) {
          $scope.showNull = !records.length > 0;
          if (res.errorCode == '000002') {
            if(confirmPopup == null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
          }
         });
       }
   });

   return controller;
 });
