define(['projectList.boot'], function(require){
  'use strict';

  var service = angular.module('projectList.services');
  service.factory('ProjectService', function($q, $http, $log,Storage, $base64, ENV) {
    return {
      //获取列表
      specialtyTypeList: function(){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/project/specialtyTypeList',
              dataType: "json",
              params: {

              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          projectGradeList: function(){
                var deferred = $q.defer(),
                    promise = deferred.promise;
                $http({
                  method: 'POST',
                  url: ENV.api + '/project/projectGradeList',
                  dataType: "json",
                  params: {

                  }
                }).success(function(res){
                    if(res && res.success){
                      deferred.resolve(res.record);
                    } else {
                      deferred.reject(res);
                    }
                });

                promise.success = function(fn) {
                    promise.then(fn);
                    return promise;
                }
                promise.error = function(fn) {
                    promise.then(null, fn);
                    return promise;
                }
                return promise;
              },
              isOrg: function(usertoken){
                    var deferred = $q.defer(),
                        promise = deferred.promise;
                    $http({
                      method: 'POST',
                      url: ENV.api + '/project/isOrg',
                      dataType: "json",
                      params: {
                        usertoken:usertoken
                      }
                    }).success(function(res){
                        if(res && res.success){
                          deferred.resolve(res.record);
                        } else {
                          deferred.reject(res);
                        }
                    });

                    promise.success = function(fn) {
                        promise.then(fn);
                        return promise;
                    }
                    promise.error = function(fn) {
                        promise.then(null, fn);
                        return promise;
                    }
                    return promise;
                  },
      //获取项目
      getProjectList: function(start, limit,specialty,level,orgId,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/project/getProjectList',
              dataType: "json",
              params: {
                start : start,
                limit : limit,
                specialty : specialty,
                level : level,
                orgId : orgId,
                usertoken : usertoken
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res.record);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          //站点
        subprojectList: function(start,limit,projectId,status,usertoken){
              var deferred = $q.defer(),
                  promise = deferred.promise;
              $http({
                method: 'POST',
                url: ENV.api + '/project/subprojectList',
                dataType: "json",
                params: {
                  projectId:projectId,
                  status : status,
                  start : start,
                  limit : limit,
                  usertoken : usertoken
                }
              }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
              });

              promise.success = function(fn) {
                  promise.then(fn);
                  return promise;
              }
              promise.error = function(fn) {
                  promise.then(null, fn);
                  return promise;
              }
              return promise;
            },
        getProjectDetail: function(projectId,usertoken){
              var deferred = $q.defer(),
                  promise = deferred.promise;
              $http({
                method: 'POST',
                url: ENV.api + '/project/getProjectDetail',
                dataType: "json",
                params: {
                  projectId:projectId,
                  usertoken : usertoken
                }
              }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
              });

              promise.success = function(fn) {
                  promise.then(fn);
                  return promise;
              }
              promise.error = function(fn) {
                  promise.then(null, fn);
                  return promise;
              }
              return promise;
            },
          //站点任务下面的执行人
        subprojectPersonList: function(subprojectId,usertoken){
              var deferred = $q.defer(),
                  promise = deferred.promise;
              $http({
                method: 'POST',
                url: ENV.api + '/project/subprojectPersonList',
                dataType: "json",
                params: {
                  subprojectId:subprojectId,
                  usertoken : usertoken
                }
              }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
              });

              promise.success = function(fn) {
                  promise.then(fn);
                  return promise;
              }
              promise.error = function(fn) {
                  promise.then(null, fn);
                  return promise;
              }
              return promise;
            },
        getOrg: function(usertoken,ename){
              var deferred = $q.defer(),
                  promise = deferred.promise;
              $http({
                method: 'POST',
                url: ENV.api + '/project/getOrg',
                dataType: "json",
                params: {
                  usertoken : usertoken,
                  ename:ename
                }
              }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
              });

              promise.success = function(fn) {
                  promise.then(fn);
                  return promise;
              }
              promise.error = function(fn) {
                  promise.then(null, fn);
                  return promise;
              }
              return promise;
            },
    };
  });
  return service;
});
