define(['qLists.boot'], function (require) {
  'use strict';

  var service = angular.module('qLists.services');
  service.factory('QListsService', function ($q, $http, $log, $base64, ENV,Storage) {
    return {
      getTroubleList: function (start,limit,isViolation,status,level,type) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/getTroubleList',
          dataType: "json",
          params: {
            start:start,
            limit:limit,
            isViolation:isViolation,
            status:status,
            level:level,
            type:type,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getTaskTroubleList: function (taskId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/getTroubleList',
          dataType: "json",
          params: {
            start:0,
            limit:99999,
            projectTaskId:taskId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getTrouble: function (troubleId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/getTrouble',
          dataType: "json",
          params: {
            troubleId:troubleId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getFollowUpAndSupervisePower: function (troubleId) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/getFollowUpAndSupervisePower',
          dataType: "json",
          params: {
            troubleId:troubleId,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doSupervise: function (troubleId,superviseNote,superviseTime) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/doSupervise',
          dataType: "json",
          params: {
            troubleId:troubleId,
            superviseNote:superviseNote,
            superviseTime:superviseTime,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      doFollowUp: function (troubleId,status,description) {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/trouble/doFollowUp',
          dataType: "json",
          params: {
            troubleId:troubleId,
            status:status,
            description:description,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      }
    };
  });
  return service;
});
