define(['riskWarning.boot'], function (require) {
  'use strict';

  var controller = angular.module('riskWarning.controllers');

  controller.controller('RiskWarningController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, PersonnelService,RiskWarningService,$stateParams,$sce) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.projectTaskId = $stateParams.projectTaskId;
    $scope.type = $stateParams.type;
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    RiskWarningService.getWorkMessage($scope.projectTaskId,$scope.type)
      .success(function (res) {
        $ionicLoading.hide();
        if (res && res.record) {
          $scope.item = $sce.trustAsHtml(res.record);
        }
      }).error(function (data) {
        $ionicLoading.hide();
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });
  });


  return controller;
});
