define(['riskWarning.boot'], function(require){
  'use strict';

  var service = angular.module('riskWarning.services');
  service.factory('RiskWarningService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      getWorkMessage: function(projectTaskId,type){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getWorkMessage',
          dataType: "json",
          params:{
            projectTaskId:projectTaskId,
            type:type,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      }

    };
  });
  return service;
});
