define(['safetyCheckRecord.boot'], function (require) {
  'use strict';

  var controller = angular.module('safetyCheckRecord.controllers');

  controller.controller('CheckDetailsController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$stateParams, Storage, SafetyCheckRecordService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    //多图片预览变量
    $scope.imgShou = [];
    $scope.soDoImg = [];
    $scope.activeImgIndex = undefined;

    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = '/file/getPic?id='+item+'&isCompress=false';
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, ENV.api, function (success) {
        }, function (error) {
        }
      );
    };
    $scope.hideBigImage = function () {

      $scope.bigImage = false;
    };
    var id = $stateParams.id;
    $scope.source = $stateParams.source;
    var usertoken =  Storage.get("userInfo").usertoken;
    SafetyCheckRecordService.getCheckDetail(id,usertoken)
    .success(function (res) {
    if(res){
       $ionicLoading.hide();
      $scope.data = res.data;

     if ($scope.data.status == 2) {
        $scope.safeContStyle = {
           "bottom": "50px"
        }
     } else {
       $scope.safeContStyle = {
          "bottom": "0px"
       }
     }

      //有人说你一个人到处旅行走走停停---多图片预览图片展示前戏
      for (var i = 0; i < res.data.imgList.length; i++) {

        $scope.imgShou[i] = ENV.api + '/file/getPic?id='+ res.data.imgList[i]  +'&isCompress=false';

      }
    }
    }).error(function (res) {
       $ionicLoading.hide();
       if (res.errorCode == '000002') {
         var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       } else  if (res.errorCode == '001008') {
         $ionicLoading.show({
           template: res.msg,
           duration: 800
         });
       }
     });

  });
  controller.controller('SCFollowUpController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $state, $stateParams, $ionicActionSheet, $cordovaImagePicker,SafetyCheckRecordService , Storage,$ionicHistory) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    var id = $stateParams.id;
    var usertoken =  Storage.get("userInfo").usertoken;
    var middleJ = '';
    var stateM = $stateParams.statement;

    if (stateM == 1) {
      middleJ = '通过';
      $scope.initialState = '通过';

      $scope.notJ = true;
      $scope.isJ = false;
      $scope.stayJ = false;
    }  else if (stateM == 2) {

      middleJ = '未通过';
      $scope.initialState = '未通过';

      $scope.notJ = false;
      $scope.isJ = true;
      $scope.stayJ = false;
    }


    $scope.sDone = function (str) {

      if (str == 'notJ') {

        $scope.notJ = true;
        $scope.isJ = false;
        $scope.stayJ = false;

        middleJ = '通过';
      } else if (str === 'isJ') {

        $scope.notJ = false;
        $scope.isJ = true;
        $scope.stayJ = false;

        middleJ = '未通过';
      }
    };

    $scope.showPopupFollowUp = function (node) {
      var myPopupOne = $ionicPopup.show({
        template: '<div class="item mine-item" ng-click="sDone(\'notJ\')"><span class="icon pull-right-5" style="margin-top: 0px;font-size: 16px !important;color:#51bb7d;" ng-class=\'{true: "ion-android-done", false:""}[notJ]\'></span>' +
        '<span class="main-word-item">通过</span>' +
        '</div>' +
        '<div class="item mine-item" ng-click="sDone(\'isJ\')"><span class="icon pull-right-5" style="margin-top: 0px;font-size: 16px !important;color:#51bb7d;" ng-class=\'{true: "ion-android-done", false:""}[isJ]\'></span>' +
        '<span class="main-word-item">不通过</span>' +
        '</div>',
        title: '请选择',
        scope: $scope,
        buttons: [
          {
            text: '<b>确定</b>',
            type: 'button-assertive',
            onTap: function (e) {
              return true;
            }
          }
        ]
      });

      myPopupOne.then(function (res) {
        if (!res) {
          return false;
        } else {
          $scope.initialState = middleJ;
        }

      });
    }

    $scope.description = {description:''};

    /*图片上传*/
    $scope.imgs = [];

    $scope.bigImage = false;
      $scope.hideBigImage = function () {

        $scope.bigImage = false;
      };


    $scope.onSubmit = function () {
      var status = 0;
      if ($scope.notJ) {
        status = 1;
      } else if ($scope.isJ) {
        status = 2;
      };
      if(status==0){
        $scope.showAlert("请选择是否通过");
        return;
      }
      if ($scope.description.description == "") {
        $scope.showAlert("请填写检查描述");
        return;
      }

      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      SafetyCheckRecordService.doFollowUp(id,usertoken,status,$scope.description.description)
        .success(function (res) {
          var imgArr = $scope.imgs;
          if (imgArr.length == 0) {// 没有图片
            $ionicLoading.hide();
            $timeout(function () {
              $state.go("checkDetails", {id: id,source:'app'}, {reload: true});
            }, 1000);
          } else {// 有图片
            angular.forEach(imgArr, function (data, index, array) {
              //data等价于array[index]
              var fileURL = data;
              if (index == imgArr.length - 1) {  // 是否是最后一张
                $scope.upload(fileURL,res.entity, true);
              } else {
                $scope.upload(fileURL,res.entity, false);
              }
            });
          }
        }).error(function (data) {
          $ionicLoading.hide();
          $scope.showAlert(data.msg);
        });
    };


    $scope.onAddPic = function () {
      if ($scope.imgs.length >= 9) {
        $scope.showAlert("上传图片数量上限");
        return;
      }
      $ionicActionSheet.show({
        buttons: [
          {text: '立即拍摄'},
          {text: '从相册中选择'}
        ],
        titleText: '请选择图片来源',
        cancelText: '返回',
        cancel: function () {
          $log.log('cancel');
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.onTakePhoto();  // 调用照相功能
              break;
            case 1:
              $scope.onAddFromAlbum();  // 调用选择图片功能
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    $scope.onAddFromAlbum = function () {
      var options = {
         maximumImagesCount: 9, //需要显示的图片的数量
         width: 800,
         height: 800,
         quality: 100
        };
       $cordovaImagePicker.getPictures(options)
          .then(function (results) {
            if(Array.isArray(results)) {
              for (var i = 0; i < results.length; i++) {
                $scope.imgs.push(results[i]);
              }
              $scope.$apply();
            }
          }, function(error) {
            // error getting photos
          });
    };
    // 照相功能
    $scope.onTakePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        targetHeight: 450,
        targetWidth: 350
      };
      navigator.camera.getPicture(function (fileURL) {
          $scope.imgs.push(fileURL);
          $scope.$apply();
        },
        function () {//if error
        },
        options);
    };

    // 删除图片
    $scope.deleteImg = function (index) {
      var confirmPopup = $ionicPopup.confirm({
        title: '删除图片',
        template: '确定删除第' + (index + 1) + '张图片吗?',
        cancelText: '取消',
        okText: '确定',
        okType: 'button-calm'
      });
      confirmPopup.then(function (res) {
        if (res) {
          $scope.imgs.splice(index, 1);
          $scope.$apply();
        } else {
          console.log('You are not sure');
        }
      });
    };
    $scope.upload = function (fileURL,entity ,final) {
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = fileURL.substring(fileURL.lastIndexOf('/') + 1);
      if(options.fileName.indexOf('?') != -1){
        options.fileName = options.fileName.substring(0,options.fileName.indexOf('?'));
      }
      options.mimeType = "image/jpeg";
      var params = {
        usertoken: Storage.get('userInfo').usertoken,
        tableId:entity.id,
        tableName: "cm_security_check",
        projectId: entity.projectId,
        checkName: entity.checkName
      };
      options.params = params;
      var ft = new FileTransfer();
      ft.upload(
        fileURL,
        encodeURI(ENV.api + "/securityCheck/doUploadPic"),
        function(){
          if (final) {//如果是最后一张
            $ionicLoading.hide();
            $timeout(function () {
             $state.go("checkDetails", {id: id,source:'app'}, {reload: true});
            }, 1000);
          }
        },
        function () {//失败
          console.log("图片上传失败");
          $ionicLoading.hide();
        },
        options
      );
    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = item;
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, '', function (success) {
        }, function (error) {
        }
      );
    };
  });
  return controller;
});
