define(['safetyCheckRecord.boot'], function(require){
  'use strict';

  var service = angular.module('safetyCheckRecord.services');
  service.factory('SafetyCheckRecordService', function($q, $http, $log,Storage, $base64, ENV) {
    return {
      //获取列表
      getCheckRecordListByCheckId: function(start,limit,checkId,source,isSolve,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/securityCheck/getCheckRecordListByCheckId',
              dataType: "json",
              params: {
                checkId:checkId,
                source : source,
                start : start,
                isSolve: isSolve,
                limit : limit,
                usertoken : usertoken
              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });
            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      getCheckDetail: function(id,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/securityCheck/getCheckDetail',
              dataType: "json",
              params: {
                id:id,
                usertoken : usertoken
              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });
            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
      getCheckRecordList: function(start,limit,source,checkType,isSolve,usertoken){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/securityCheck/getCheckRecordList',
              dataType: "json",
              params: {
                source:source,
                checkType : checkType,
                start : start,
                isSolve: isSolve,
                limit : limit,
                usertoken : usertoken
              }
            }).success(function(res){
                if(res && res.success){
                  deferred.resolve(res.record);
                } else {
                  deferred.reject(res);
                }
            });
            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          doFollowUp: function(id,usertoken,status,description){
                var deferred = $q.defer(),
                    promise = deferred.promise;
                $http({
                  method: 'POST',
                  url: ENV.api + '/securityCheck/doFollowUp',
                  dataType: "json",
                  params: {
                    id:id,
                    usertoken : usertoken,
                    status:status,
                    description:description
                  }
                }).success(function(res){
                    if(res && res.success){
                      deferred.resolve(res.record);
                    } else {
                      deferred.reject(res);
                    }
                });
                promise.success = function(fn) {
                    promise.then(fn);
                    return promise;
                }
                promise.error = function(fn) {
                    promise.then(null, fn);
                    return promise;
                }
                return promise;
              },
              getCheckRecordNum: function(usertoken){
                    var deferred = $q.defer(),
                        promise = deferred.promise;
                    $http({
                      method: 'POST',
                      url: ENV.api + '/securityCheck/getCheckRecordNum',
                      dataType: "json",
                      params: {

                        usertoken : usertoken
                      }
                    }).success(function(res){
                        if(res && res.success){
                          deferred.resolve(res.record);
                        } else {
                          deferred.reject(res);
                        }
                    });
                    promise.success = function(fn) {
                        promise.then(fn);
                        return promise;
                    }
                    promise.error = function(fn) {
                        promise.then(null, fn);
                        return promise;
                    }
                    return promise;
                  }


    };
  });
  return service;
});
