/*
* @Author: HuangTiger
* @Date:   2017-05-27 14:12:59
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-09-13 11:08:32
*/

define(['taskarrangement.boot'], function (require) {
  'use strict';


  var controller = angular.module('taskarrangement.controllers', ['ion-tree-list']);
  controller.controller('TaskMainController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal) {

  });


  controller.controller('TaskArrangementController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading,$cordovaKeyboard, $ionicScrollDelegate,$ionicModal, $state, Storage, TaskService) {
    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });
    var confirmPopup = null;
    $scope.usertoken = Storage.get('userInfo').usertoken;
    $scope.projects = [];
    $scope.key="";
    $scope.showNull = false;
    $scope.hasMore = false;
    $scope.start=0;
    $scope.limit=15;
    $scope.loadMore = function () {
    TaskService.getProject($scope.usertoken,$scope.start,$scope.limit,$scope.key)
    .success(function (data) {
      if(data){
        var records = data.record.projectList;
        $scope.start = $scope.start + records.length;;
        $scope.projects = $scope.projects.concat(records);
        if(records.length >= $scope.limit){
          $scope.hasMore = true;
        } else{
          $scope.hasMore = false;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }else{
        $scope.hasMore = false;
      }
      $scope.showNull = !$scope.projects.length > 0;
     $ionicLoading.hide();
    }).error(function (data) {
        $ionicLoading.hide();
        //无数据
        $scope.showNull = true;

        if(data == null){
          $ionicLoading.show({
           template: "服务器异常，请稍后再试。",
           duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(confirmPopup == null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
           template: data.msg,
           duration: 800
          });
        }
     });
   };
   $scope.loadMore();
   $scope.todoSomething=function($event){

     if($event.keyCode==13){//回车
       $scope.startDot();
     }
   };
   $scope.startDot = function() {//判断清除输入框的图标是否显示
     $ionicLoading.show({
       template: '加载中，请稍候...',
       noBackdrop: true
     });
     $scope.start = 0;
     $scope.projects = [];


     if($scope.key.length==0 || $scope.key=="") {
       $scope.searchEmptyShow=false;
     }else{
       $scope.searchEmptyShow=true;
     }
      $cordovaKeyboard.close();
       $ionicScrollDelegate.scrollTop();
        $scope.loadMore();
   };



  });


  controller.controller('TaskController', function (ENV, $scope, $log,$state, $timeout, $rootScope,$cordovaKeyboard, $ionicPopup, $ionicLoading,$ionicScrollDelegate, $ionicModal, TaskService, Storage) {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      var confirmPopup = null;
      $scope.key='';
      $scope.usertoken = Storage.get('userInfo').usertoken;
      $scope.projects = [];
      $scope.showNull = false;
      $scope.start=0;
      $scope.limit=15;
      $scope.loadMore = function () {
      TaskService.getTaskProject($scope.usertoken,$scope.start,$scope.limit,$scope.key)
      .success(function (data) {
         if(data){
           var records = data.record.projectList;
           $scope.start = $scope.start + records.length;;
           $scope.projects = $scope.projects.concat(records);
           if(records.length >= $scope.limit){
             $scope.hasMore = true;
           } else{
             $scope.hasMore = false;
           }
           $scope.$broadcast('scroll.infiniteScrollComplete');
         }else{
           $scope.hasMore = false;
         }
         $scope.showNull = !$scope.projects.length > 0;
        $ionicLoading.hide();
      }).error(function (data) {
          $ionicLoading.hide();
          //无数据
          $scope.showNull = true;
          if(data == null){
            $ionicLoading.show({
             template: "服务器异常，请稍后再试。",
             duration: 800
            });
          } else if (data.errorCode == '000002') {
            if(confirmPopup == null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
          } else {
            $ionicLoading.show({
             template: data.msg,
             duration: 800
            });
          }
       });
     };
       $scope.loadMore();
       $scope.todoSomething=function($event){

         if($event.keyCode==13){//回车
            $scope.startDot();
         }
       };
       $scope.startDot = function() {//判断清除输入框的图标是否显示
         $ionicLoading.show({
           template: '加载中，请稍候...',
           noBackdrop: true
         });
         $scope.start = 0;
         $scope.projects = [];
         if($scope.key.length==0 || $scope.key=="") {
           $scope.searchEmptyShow=false;
         }else{
           $scope.searchEmptyShow=true;

         }
          $ionicScrollDelegate.scrollTop();

         $scope.loadMore();
  $cordovaKeyboard.close();
       };

  });
  controller.controller('SubController', function (ENV, $scope, $log,$state, $timeout, $rootScope, $ionicPopup, $cordovaKeyboard,$ionicLoading, $ionicModal, $ionicHistory,$ionicScrollDelegate,TaskService,$stateParams, Storage) {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      $scope.History = {
        goBack: function () {
          $ionicHistory.goBack();
        }
      };
      var confirmPopup = null;
      $scope.projectId=$stateParams.projectId;
      $scope.usertoken = Storage.get('userInfo').usertoken;
      $scope.subs = [];
      $scope.key='';
      $scope.showNull = false;
      $scope.start=0;
      $scope.limit=15;
      $scope.loadMore = function () {
      TaskService.getSubs($scope.projectId,$scope.usertoken,$scope.start,$scope.limit,$scope.key)
      .success(function (data) {
        if(data){
          var records = data.record.subs;
          $scope.start = $scope.start + records.length;;
          $scope.subs = $scope.subs.concat(records);
          if(records.length >= $scope.limit){
            $scope.hasMore = true;
          } else{
            $scope.hasMore = false;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }else{
          $scope.hasMore = false;
        }
        $scope.showNull = !$scope.subs.length > 0;
       $ionicLoading.hide();
      }).error(function (data) {
          $ionicLoading.hide();
          //无数据
          $scope.showNull = true;
          if(data == null){
            $ionicLoading.show({
             template: "服务器异常，请稍后再试。",
             duration: 800
            });
          } else if (data.errorCode == '000002') {
            if(confirmPopup == null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
          } else {
            $ionicLoading.show({
             template: data.msg,
             duration: 800
            });
          }
       });
     };
       $scope.loadMore();
       $scope.todoSomething=function($event){

         if($event.keyCode==13){//回车
            $scope.startDot();
         }
       };
       $scope.startDot = function() {//判断清除输入框的图标是否显示
         $ionicLoading.show({
           template: '加载中，请稍候...',
           noBackdrop: true
         });
         $scope.start = 0;
         $scope.subs = [];
         if($scope.key.length==0 || $scope.key=="") {
           $scope.searchEmptyShow=false;
         }else{
           $scope.searchEmptyShow=true;

         }
         $cordovaKeyboard.close();
         $scope.loadMore();
         $ionicScrollDelegate.scrollTop();
       };

  });

  return controller;
});
