define(['personManage.boot'], function(require){
  'use strict';

  var service = angular.module('portal.services');
  service.factory('TaskService', function($q, $http, $log, $base64, ENV) {
    return {
      //获取通讯录列表
      getProject: function(usertoken,start,limit,key){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/arraygeTask/getProject',
              dataType: "json",
              params: {
                usertoken : usertoken,
                start : start,
                limit : limit,
                key : key
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          },
          getSubs: function(projectId,usertoken,start,limit,key){
                var deferred = $q.defer(),
                    promise = deferred.promise;

                $http({
                  method: 'POST',
                  url: ENV.api + '/arraygeTask/getSubs',
                  dataType: "json",
                  params: {
                    projectId : projectId,
                    usertoken : usertoken,
                    start : start,
                    limit : limit,
                    key : key
                  }
                }).success(function(res){
                  if(res && res.success){
                    deferred.resolve(res);
                  } else {
                    deferred.reject(res);
                  }
                });

                promise.success = function(fn) {
                    promise.then(fn);
                    return promise;
                }
                promise.error = function(fn) {
                    promise.then(null, fn);
                    return promise;
                }
                return promise;
              },
      getTaskProject: function(usertoken,start,limit,key){
            var deferred = $q.defer(),
                promise = deferred.promise;
            $http({
              method: 'POST',
              url: ENV.api + '/arraygeTask/getTaskProject',
              dataType: "json",
              params: {
                usertoken : usertoken,
                start : start,
                limit : limit,
                key : key
              }
            }).success(function(res){
              if(res && res.success){
                deferred.resolve(res);
              } else {
                deferred.reject(res);
              }
            });

            promise.success = function(fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function(fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
          }

    };
  });
  return service;
});
