define(['todaytask.boot'], function(require){
  'use strict';

  var service = angular.module('todaytask.services');
  service.factory('TodayTaskService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      getSubProjectTree: function(start,limit,status,type,projectId,name){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getSubProjectTree',
          dataType: "json",
          params:{
            name:name,
            projectId:projectId,
            start:start,
            limit:limit,
            status:status,
            type:type,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getProject: function(status,type,start,limit,name){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getProject',
          dataType: "json",
          params:{
            start:start,
            limit:limit,
            name:name,
            status:status,
            type:type,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      },
      getTaskList: function(start,limit,projectId,projectSubId,status,type){
        var deferred = $q.defer(),
          promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/todayTask/getTaskList',
          dataType: "json",
          params:{
            start:start,
            limit:limit,
            projectId:projectId,
            projectSubId:projectSubId,
            status:status,
            type:type,
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function(res){
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }
        });

        promise.success = function(fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function(fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      }

    };
  });
  return service;
});
